#ifndef _MODBUS_MSXE312X_CLIENT_DEFINITION_H_
#define _MODBUS_MSXE312X_CLIENT_DEFINITION_H_

/* this file has been generated by gModbus on Tue Aug 20 16:21:27 2013*/

#include "common_modbus_clientlib.h"



/* Symbolic names for register */
enum {
MSXE312X__ANALOGINPUTGETNUMBEROFCHANNELS=23000,
MSXE312X__ANALOGINPUTGETCHANNELSTYPE=23050,
MSXE312X__ACQUISITIONGETNUMBEROFCHANNELS=15000,
MSXE312X__ACQUISITIONGETCHANNELSINFO=15050,
MSXE312X__ACQUISITIONAUTOREFRESHGETVALUES=15300,
MSXE312X__ACQUISITIONAUTOREFRESHGETBLOCKINGVALUES=15450,
MSXE312X__ACQUISITIONAUTOREFRESHGETCONFIGURATION=15600,
MSXE312X__ACQUISITIONSEQUENCEGETCONFIGURATION=15650,
MSXE312X__ANALOGOUTPUTGETNUMBEROFCHANNELS=35000,
MSXE312X__DIGITALIOGETNUMBEROFCHANNELS=26000,
MSXE312X__DIGITALIOGETPORTAVAILABLEDIRECTIONS=26100,
MSXE312X__DIGITALIOGETPORTDIRECTIONS=26150,
MSXE312X__DIGITALIOGETINPUTSFILTERCONFIGURATION=26200,
MSXE312X__DIGITALIOTESTOUTPUTSSHORTCIRCUIT=26250,
MSXE312X__DIGITALIOREADCHANNEL=26300,
MSXE312X__DIGITALIOREADPORT=26350,
};

#ifdef WIN32
#pragma pack(1)
#endif // WIN32

struct MSXE312x__AnalogInputGetNumberOfChannels_parameters_t
{
	uint32_t ulNumber;
 } __PACKED;

struct MSXE312x__AnalogInputGetChannelsType_parameters_t
{
	uint32_t ulType[8];
	uint32_t ulICP[8];
 } __PACKED;

struct MSXE312x__AcquisitionGetNumberOfChannels_parameters_t
{
	uint32_t ulNumber;
 } __PACKED;

struct MSXE312x__AcquisitionGetChannelsInfo_parameters_t
{
	uint32_t ulType[16];
	uint32_t ulHwPosition[16];
	uint32_t ulChannelIndex[16];
 } __PACKED;

struct MSXE312x__AcquisitionAutoRefreshGetValues_parameters_t
{
	uint32_t ulTimeStampLow;
	uint32_t ulTimeStampHigh;
	uint32_t ulCounterValue;
	float fValues[16];
 } __PACKED;

struct MSXE312x__AcquisitionAutoRefreshGetBlockingValues_parameters_t
{
	uint32_t ulTimeStampLow;
	uint32_t ulTimeStampHigh;
	uint32_t ulCounterValue;
	float fValues[16];
 } __PACKED;

struct MSXE312x__AcquisitionAutoRefreshGetConfiguration_parameters_t
{
	uint32_t ulChannelMask;
	uint32_t ulAverageValue;
	uint32_t ulRefreshTime;
	uint32_t ulRefreshTimeUnit;
	uint32_t ulTriggerMask;
	uint32_t ulTriggerMode;
	uint32_t ulHardwareTriggerEdge;
	uint32_t ulHardwareTriggerCount;
	uint32_t ulByTriggerNbrOfSeqToAcquire;
	uint32_t ulDataFormat;
	uint32_t ulRunning;
 } __PACKED;

struct MSXE312x__AcquisitionSequenceGetConfiguration_parameters_t
{
	uint32_t ulNbrOfChannel;
	uint32_t ulChannelList[16];
	uint32_t ulAcquisitionTime;
	uint32_t ulAcquisitionTimeUnit;
	uint32_t ulNbrOfSequence;
	uint32_t ulNbrMaxSequenceToTransfer;
	uint32_t ulTriggerMask;
	uint32_t ulTriggerMode;
	uint32_t ulHardwareTriggerEdge;
	uint32_t ulHardwareTriggerCount;
	uint32_t ulByTriggerNbrOfSeqToAcquire;
	uint32_t ulDataFormat;
	uint32_t ulRunning;
 } __PACKED;

struct MSXE312x__AnalogOutputGetNumberOfChannels_parameters_t
{
	uint32_t ulNumber;
 } __PACKED;

struct MSXE312x__DigitalIOGetNumberOfChannels_parameters_t
{
	uint32_t ulNumber;
 } __PACKED;

struct MSXE312x__DigitalIOGetPortAvailableDirections_parameters_t
{
	uint32_t ulInputs;
	uint32_t ulOutputs;
 } __PACKED;

struct MSXE312x__DigitalIOGetPortDirections_parameters_t
{
	uint32_t ulDirection;
 } __PACKED;

struct MSXE312x__DigitalIOGetInputsFilterConfiguration_parameters_t
{
	uint32_t ulFilterTime;
	uint32_t ulFilter;
 } __PACKED;

struct MSXE312x__DigitalIOTestOutputsShortCircuit_parameters_t
{
	uint32_t ulState;
 } __PACKED;

struct MSXE312x__DigitalIOReadChannel_parameters_t
{
	uint32_t ulState;
 } __PACKED;

struct MSXE312x__DigitalIOReadPort_parameters_t
{
	uint32_t ulState;
 } __PACKED;

#ifdef WIN32
#pragma pack()
#endif // WIN32



/** <p>Return the number of analog input channels.</p>
* <p><b>Parameters</b></p>
* <ul>
* 	<li>@param[out] <b> <VAR>ulNumber </VAR> </b> Return the number of available analog input channels</li>
* </ul>
* <p><b>Returns</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
			


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MSXE312x__AnalogInputGetNumberOfChannels(struct modbus * modbus,struct MSXE312x__AnalogInputGetNumberOfChannels_parameters_t * Response);



/** <p>Return the type of the analog input channels.</p>
* <p><b>Parameters</b></p>
* <ul>
* 	<li>@param[out] <b> <VAR>ulType </VAR> </b> Array that contain the channels type (0 : Voltage, 1 : Current)
* 		<ul>
*			<li> ulType [0] : Channel 0 type</li>
*			<li> ...</li>
*			<li> ulType [7] : Channel 7 type</li>
*		</ul>
*	</li>
* 	<li>@param[out] <b> <VAR>ulICP </VAR> </b> Array that contain if ICP available (0 : not available, 1 : available)
* 		<ul>
*			<li> ulICP [0] : Channel 0 ICP information</li>
*			<li> ...</li>
*			<li> ulICP [7] : Channel 7 ICP information</li>
* 		</ul>
*	</li>
* </ul>
* <p><b>Returns</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
			


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MSXE312x__AnalogInputGetChannelsType(struct modbus * modbus,struct MSXE312x__AnalogInputGetChannelsType_parameters_t * Response);



/** <p>Return the number of acquisition channels.</p>
* <p><b>Parameters</b></p>
* <ul>
* 	<li>@param[out] <b> <VAR>ulNumber </VAR> </b> Return the number of available acquisition channels</li>
* </ul>
* <p><b>Returns</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
			


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MSXE312x__AcquisitionGetNumberOfChannels(struct modbus * modbus,struct MSXE312x__AcquisitionGetNumberOfChannels_parameters_t * Response);



/** <p>Return the acquisition channels type and hardware position.</p>
* <p><b>Parameters:</b></p>
* <ul>
* 	<li>@param[out] <b> <VAR>ulType </VAR> </b> Array that contains the channels type.
* 		<ul>
*			<li> 0 : Not available </li>
*			<li> 1 : Temperature channel </li>
*			<li> 2 : Pressure channel </li>
*			<li> 3 : Transducer channel </li>
*			<li> 4 : Analog input channel </li>
*			<li> 5 : Analog input ICP channel </li>
*			<li> 6 : Digital I/O port </li>
*		</ul>
*		<ul>
*			<li> ulType [0] : Channel 0 type</li>
*			<li> ...</li>
*			<li> ulType [15] : Channel 15 type</li>
*		</ul>
*	</li>
*	<li>@param[out] <b> <VAR>ulHwPosition </VAR> </b> Array that contain the hardware position index (0 to 7)
* 		<ul>
*			<li> ulType [0] : Channel 0 hardware position index</li>
*			<li> ...</li>
*			<li> ulType [15] : Channel 15 hardware position index</li>
*		</ul>
* 	</li>
*	<li>@param[out] <b> <VAR>ulChannelIndex </VAR> </b> Array that contain the functionality channel index.
* 		<ul>
*			<li> ulType [0] : Channel 0 hardware position index</li>
*			<li> ...</li>
*			<li> ulType [15] : Channel 15 functionality channel index</li>
*		</ul>
*	</li>
* </ul>
* <p><b>Returns</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-2</b> Channel selection wrong</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
			


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MSXE312x__AcquisitionGetChannelsInfo(struct modbus * modbus,struct MSXE312x__AcquisitionGetChannelsInfo_parameters_t * Response);



/** <p> Returns the values acquired in auto refresh mode</p>
* <p><b>Parameters:</b></p>
* <ul>
* 	<li>@param[out] <b> <VAR>ulTimeStampLow</VAR> </b> Number of microseconds since epoch</li>
* 	<li>@param[out] <b> <VAR>ulTimeStampHigh </VAR> </b> Number of seconds since epoch</li>
* 	<li>@param[out] <b> <VAR>ulAutoRefreshCounter </VAR> </b> Number of sequence acquisition since the start</li>
* 	<li>@param[out] <b> <VAR>fValues </VAR> </b> Array that contains the channels values
*		<ul>
*			<li> pdValues [0] : Channel 0 value</li>
*			<li>  ...</li>
*			<li> pdValues [15] : Channel 15 value</li>
* 		</ul>
*	</li>
* <p><b> Returns:</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-2</b> No Acquisition in progress</li>
*	<li><b>-3</b> 2s timeout occur (If you have enabled the blocking mode).</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
			


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MSXE312x__AcquisitionAutoRefreshGetValues(struct modbus * modbus,struct MSXE312x__AcquisitionAutoRefreshGetValues_parameters_t * Response);



/** <p> Returns the values acquired in auto refresh mode after a new cycle occur (wait a new auto refresh value cycle)</p>
* <p><b>Parameters:</b></p>
* <ul>
* 	<li>@param[out] <b> <VAR>ulTimeStampLow</VAR> </b> Number of microseconds since epoch</li>
* 	<li>@param[out] <b> <VAR>ulTimeStampHigh </VAR> </b> Number of seconds since epoch</li>
* 	<li>@param[out] <b> <VAR>ulAutoRefreshCounter </VAR> </b> Number of sequence acquisition since the start</li>
* 	<li>@param[out] <b> <VAR>fValues </VAR> </b> Array that contains the channels values
*		<ul>
*			<li> pdValues [0] : Channel 0 value</li>
*			<li>  ...</li>
*			<li> pdValues [15] : Channel 15 value</li>
* 		</ul>
*	</li>
* <p><b> Returns:</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-2</b> No Acquisition in progress</li>
*	<li><b>-3</b> 2s timeout occur (If you have enabled the blocking mode).</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
			


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MSXE312x__AcquisitionAutoRefreshGetBlockingValues(struct modbus * modbus,struct MSXE312x__AcquisitionAutoRefreshGetBlockingValues_parameters_t * Response);



/** <p> Get the current auto refresh acquisition configuration. </p>
* <p><b>Parameters:</b></p>
* <ul>
* 	<li>@param[out] <b><VAR> ulChannelMask </VAR></b> Mask of the channel acquired by the auto refresh (1 bit = 1 Channel). If the value returned is 0, then the auto refresh acquisition is not initialised. </li>
* 	<li>@param[out] <b><VAR> ulAverageValue </VAR></b> Average value
*		<ul>
*			<li> 1 : not used </li>
*			<li> max value : 255 </li>
*		</ul>
*	</li>
*	<li>@param[out] <b><VAR> ulRefreshTimeUnit </VAR></b> Refresh Time Unit
*		<ul>
*			<li> 0 : microsecond</li>
*			<li> 1 : millisecond</li>
*			<li> 2 : second </li>
*		</ul>
*	</li>
*	<li>@param[out] <b><VAR> ulRefreshTime </VAR></b> Refresh Time
*		<ul>
*			<li> range from min 10 to 65535 when the unit is the microsecond</li>
*			<li> range from min 1 to 65535 when the unit is the millisecond</li>
*			<li> range from min 1 to 65535 when the unit is the second </li>
*		</ul>
*	</li>
* 	<li>@param[out] <b><VAR> ulTriggerMask </VAR></b> Define the source of the trigger
*		<ul>
*			<li> 0 : trigger disabled</li>
*			<li> 1 : Enable Hardware Digital Input Trigger</li>
*			<li> 2 : Enable Synchro Trigger</li>
*			<li> 3 : Enable Compare Trigger (only useful if your system has incremental counter input)</li>
*		</ul>
*	</li>
* 	<li>@param[out] <b><VAR> ulTriggerMode </VAR></b> Define the trigger mode
*		<ul>
*			<li> 1 : One shot trigger</li>
*			<li> 2 : Sequence trigger </li>
*		</ul>
*	</li>
* 	<li>@param[out] <b><VAR> ulHardwareTriggerEdge </VAR></b> Define the edge of the hardware trigger who generates a trigger action
*		<ul>
*			<li> 1 : rising edge (Only if hardware trigger selected)</li>
*			<li> 2 : falling edge (Only if hardware trigger selected)</li>
*			<li> 3 : Both front (Only if hardware trigger selected) </li>
*		</ul>
*	</li>
*	<li>@param[out] <b><VAR> ulHardwareTriggerCount </VAR></b> Define the number of trigger events before the action occur
*		<ul>
*			<li> 1 : all trigger event start the action</li>
*			<li> max value : 65535 </li>
*		</ul>
*	</li>
* 	<li>@param[out] <b><VAR> ulByTriggerNbrOfSeqToAcquire </VAR></b> Define the number of sequence to acquire by each trigger event
*		<ul>
*			<li> 0 : continuous mode</li>
*			<li> 0 : number of sequence : (1..0xFFFFFFFF) </li>
*		</ul>
*	</li>
* 	<li>@param[out] <b><VAR> ulDataFormat </VAR></b>
*		<ul>
*			<li> D0 : Absolute time stamp information
*				<ul>
*					<li> 0: no time stamp information</li>
*					<li> 1: time stamp information </li>
*				</ul>
*			</li>
*			<li> D1 : Relative time stamp information
*				<ul>
*					<li> 0: no time stamp information</li>
*					<li> 1: time stamp information </li>
*				</ul>
*			</li>
*			<li> D2 : Auto refresh counter information
*				<ul>
*					<li>  0 : No auto refresh counter information</li>
*					<li>  1 : Auto refresh counter information </li>
*				</ul>
*			</li>
*			<li> D3 : Hardware trigger information
*				<ul>
*					<li>  0 : No hardware trigger information required</li>
*					<li>  1 : Hardware trigger information required</li>
*				</ul>
*			</li>
*			<li> D4 : Data format
*				<ul>
*					<li> 0: Digital value</li>
*					<li> 1: Analog value </li>
*				</ul>
*			</li>
*		</ul>
*	</li>
* 	<li>@param[out] <b><VAR> ulRunning </VAR></b> Auto refresh acquisition running state
*		<ul>
*			<li> 0 : Not running</li>
*			<li> 1 : Auto refresh acquisition running </li>
*		</ul>
*	</li>
* </ul>
* <p><b> Returns:</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
			


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MSXE312x__AcquisitionAutoRefreshGetConfiguration(struct modbus * modbus,struct MSXE312x__AcquisitionAutoRefreshGetConfiguration_parameters_t * Response);



/** <p> Get the current sequence acquisition configuration.</p>
* <p><b>Parameters</b></p>
* <ul>
* 	<li>@param[out] <b><VAR> ulNbrOfChannel </VAR></b> Nbr of channel in the sequence. If 0 no sequence initialised</li>
* 	<li>@param[out] <b><VAR> psChannelList </VAR></b> List of the channel who compose the sequence.</li>
* 	<li>@param[out] <b><VAR> ulAcquisitionTime </VAR></b> Acquisition Time
*		<ul>
*			<li> range from min 10 to 65535 when the unit is the microsecond</li>
*			<li> range from min 1 to 65535 when the unit is the millisecond</li>
*			<li> range from min 1 to 65535 when the unit is the second</li>
*		</ul>
*	</li>
* 	<li>@param[out] <b><VAR> ulAcquisitionTimeUnit </VAR></b> Acquisition Time Unit
*		<ul>
*			<li> 0 : us</li>
*			<li> 1 : ms</li>
*			<li> 2 : s </li>
*		</ul>
*	</li>
* 	<li>@param[out] <b><VAR> ulNbrOfSequence </VAR></b> Number of sequence to acquire
*		<ul>
*			<li> 0 : continuous mode</li>
*			<li> Superior to 0 : number of sequence </li>
*		</ul>
*	</li>
* 	<li>@param[out] <b><VAR> ulNbrMaxSequenceToTransfer </VAR></b> Max number of sequence to acquire before a data transfer. (from 1 to 65535)</li>
* 	<li>@param[out] <b><VAR> ulTriggerMask </VAR></b> Define the source of the trigger
*		<ul>
*			<li> 0 : trigger disabled</li>
*			<li> 1 : Enable Hardware Digital Input Trigger</li>
*			<li> 2 : Enable Synchro Trigger</li>
*			<li> 3 : Enable Compare Trigger (only useful if your system has incremental counter input) </li>
*		</ul>
*	</li>
*	<li>@param[out] <b><VAR> ulTriggerMode </VAR></b> Define the trigger mode
*		<ul>
*			<li> 1 : One shot trigger</li>
*			<li> 2 : Sequence trigger </li>
*		</ul>
*	</li>
* 	<li>@param[out] <b><VAR> ulHardwareTriggerEdge </VAR></b> Define the edge of the hardware trigger who generate a trigger action
*		<ul>
*			<li> 1 : rising front (Only if hardware trigger selected)</li>
*			<li> 2 : falling front (Only if hardware trigger selected)</li>
*			<li> 3 : Both front (Only if hardware trigger selected) </li>
*		</ul>
*	</li>
* 	<li>@param[out] <b><VAR> ulHardwareTriggerCount </VAR></b> Define the number of trigger events before the action occur
*		<ul>
*			<li> 1 : all trigger event start the action</li>
*			<li> max value : 65535 </li>
*		</ul>
*	</li>
* 	<li>@param[out] <b><VAR> ulByTriggerNbrOfSeqToAcquire </VAR></b> define the number of sequence to acquire by each trigger event
*		<ul>
*			<li> 0 : continuous mode</li>
*			<li> Superior to 0 : number of sequence : (1..0xFFFFFFFF) </li>
*		</ul>
*	</li>
* 	<li>@param[out] <b><VAR> ulDataFormat </VAR></b> Data format option
*		<ul>
*			<li> D0 : Absolute time stamp information
*				<ul>
*					<li> 0: no time stamp information</li>
*					<li> 1: time stamp information </li>
*				</ul>
*			</li>
*			<li> D1 : Relative time stamp information
*				<ul>
*					<li> 0: no time stamp information</li>
*					<li> 1: time stamp information </li>
*				</ul>
*			</li>
*			<li> D2 : Sequence counter information
*				<ul>
*					<li> 0 : No sequence counter information</li>
*					<li> 1 : Sequence counter information</li>
*				</ul>
*			</li>
*			<li> D3 : Hardware trigger information
*				<ul>
*					<li>  0 : No hardware trigger information required</li>
*					<li>  1 : Hardware trigger information required</li>
*				</ul>
*			</li>
*			<li> D4 : Data format
*				<ul>
*					<li> 0: Digital value</li>
*					<li> 1: Analog value </li>
*				</ul>
*			</li>
*		</ul>
*	</li>
* 	<li>@param[out] <b><VAR> ulRunning </VAR></b> Sequence acquisition running state
*		<ul>
*			<li> 0 : Not running</li>
*			<li> 1 : Sequence acquisition running </li>
*		</ul>
* 	</li>
* </ul>
* <p><b> Returns:</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
			


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MSXE312x__AcquisitionSequenceGetConfiguration(struct modbus * modbus,struct MSXE312x__AcquisitionSequenceGetConfiguration_parameters_t * Response);



/** <p>Return the number of analog output channels.</p>
* <p><b>Parameters</b></p>
* <ul>
* 	<li>@param[out] <b><VAR>ulNumber</VAR></b> Return the number of available analog output channels</li>
* </ul>
* <p><b>Returns</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
			


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MSXE312x__AnalogOutputGetNumberOfChannels(struct modbus * modbus,struct MSXE312x__AnalogOutputGetNumberOfChannels_parameters_t * Response);



/** <p>Returns the number of digital I/O channels.</p>
* <p><b>Parameters</b></p>
* <ul>
* 	<li>@param[out] <b> <VAR>ulNumber </VAR> </b> Number of available digital I/O channels</li>
* </ul>
* <p><b>Returns</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
			


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MSXE312x__DigitalIOGetNumberOfChannels(struct modbus * modbus,struct MSXE312x__DigitalIOGetNumberOfChannels_parameters_t * Response);



/** <p>Returns the available directions for the selected port (input or output). The port is selected via MSXE312x__SetDataCursor.</p>
* <p><b>Parameters</b></p>
* <ul>
* 	<li>@param[out] <b> <VAR>ulInputs </VAR> </b> Digital inputs availability. Each bit indicates if the channel can be used as an input.</li>
* 	<li>@param[out] <b> <VAR>ulOutputs </VAR> </b> Digital outputs availability. Each bit indicates if the channel can be used as an output.</li>
* </ul>
* <p><b>Returns</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-2</b> The selected port (selected via MSXE312x__SetDataCursor) is wrong</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
			


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MSXE312x__DigitalIOGetPortAvailableDirections(struct modbus * modbus,struct MSXE312x__DigitalIOGetPortAvailableDirections_parameters_t * Response);



/** <p>Reads the current digital I/O direction for the selected port. The port is selected via MSXE312x__SetDataCursor.</p>
* <p><b>Parameters</b></p>
* <ul>
* 	<li>@param[out] <b> <VAR>ulDirection </VAR> </b> Current digital I/O direction. Each bit indicates if the channel is used as an input or an output (0: input, 1: output)</li>
* </ul>
* <p><b>Returns</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-2</b> The selected port (selected via MSXE312x__SetDataCursor) is wrong</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
			


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MSXE312x__DigitalIOGetPortDirections(struct modbus * modbus,struct MSXE312x__DigitalIOGetPortDirections_parameters_t * Response);



/** <p>Reads the digital inputs filter configuration for the selected port. The port is selected via MSXE312x__SetDataCursor.</p>
* <p><b>Parameters</b></p>
* <ul>
* 	<li>@param[out] <b> <VAR>ulFilterTime </VAR> </b> Filter time value (from 1 to 16777215) 1 corresponds to 250 ns, 2 corresponds to 500 ns, ...</li>
* 	<li>@param[out] <b> <VAR>ulFilter </VAR> </b> Digital inputs filter selection. Each bit indicate the filter state for one digital input channel.</li>
* </ul>
* <p><b>Returns</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-2</b> The selected port (selected via MSXE312x__SetDataCursor) is wrong</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
			


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MSXE312x__DigitalIOGetInputsFilterConfiguration(struct modbus * modbus,struct MSXE312x__DigitalIOGetInputsFilterConfiguration_parameters_t * Response);



/** <p>Get the short-circuit status of the outputs of the selected port. The port is selected via MSXE312x__SetDataCursor.</p>
* <p>The function returns a mask of bits (32 bits). Each bit represents the short-circuit state of an output.</p>
* <p>If you detect a short circuit, first solve it, and then, call the MSXE312x__DigitalIORearmOutputsShortCircuit function.</p>
* <p><b>Parameters</b></p>
* <ul>
* 	<li>@param[out] <b> <VAR>ulState </VAR> </b> Digital outputs short circuit state. Each bit represents the short-circuit state of one digital output channel.</li>
* </ul>
* <p><b>Returns</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-2</b> The selected port (selected via MSXE312x__SetDataCursor) is wrong</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
			


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MSXE312x__DigitalIOTestOutputsShortCircuit(struct modbus * modbus,struct MSXE312x__DigitalIOTestOutputsShortCircuit_parameters_t * Response);



/** <p>Read the selected digital I/O channel. The channel is selected via MSXE312x__SetDataCursor.</p>
* <p>If the selected channel is an output, then this function returns the current output state.</p>
* <p><b>Parameters</b></p>
* <ul>
* 	<li>@param[out] <b> <VAR>ulState </VAR> </b> Digital I/O channel state (0: off, 1: on)</li>
* </ul>
* <p><b>Returns</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-2</b> The selected channel (selected via MSXE312x__SetDataCursor) is wrong</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
			


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MSXE312x__DigitalIOReadChannel(struct modbus * modbus,struct MSXE312x__DigitalIOReadChannel_parameters_t * Response);



/** <p>Read the selected digital I/O port. The port is selected via MSXE312x__SetDataCursor.</p>
* <p><b>Parameters</b></p>
* <ul>
* 	<li>@param[out] <b> <VAR>ulState </VAR> </b> Digital I/O state. Each bit indicates the state of one digital I/O channel.</li>
* </ul>
* <p><b>Returns</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-2</b> The selected port (selected via MSXE312x__SetDataCursor) is wrong</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
			


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MSXE312x__DigitalIOReadPort(struct modbus * modbus,struct MSXE312x__DigitalIOReadPort_parameters_t * Response);


/* Symbolic names for register */
enum {
MSXE312X__SETDATACURSOR=65530,
MSXE312X__ANALOGINPUTSETCHANNELCONFIGURATION=23100,
MSXE312X__ANALOGINPUTSETSAMPLINGRATE=23200,
MSXE312X__ACQUISITIONAUTOREFRESHINITANDSTART=15750,
MSXE312X__ACQUISITIONAUTOREFRESHSTOPANDRELEASE=15850,
MSXE312X__ACQUISITIONSEQUENCEINITANDSTART=15900,
MSXE312X__ACQUISITIONSEQUENCESTOPANDRELEASE=15950,
MSXE312X__ANALOGOUTPUTWRITE1VALUE=35100,
MSXE312X__ANALOGOUTPUTTRIGGEROUTPUTS=35200,
MSXE312X__DIGITALIOSETPORTDIRECTIONS=26500,
MSXE312X__DIGITALIOSETINPUTSFILTERTIME=26550,
MSXE312X__DIGITALIOENABLEDISABLEINPUTSFILTER=26600,
MSXE312X__DIGITALIOREARMOUTPUTSSHORTCIRCUIT=26650,
MSXE312X__DIGITALIOWRITECHANNEL=26700,
MSXE312X__DIGITALIOWRITEPORT=26750,
};

#ifdef WIN32
#pragma pack(1)
#endif // WIN32

struct MSXE312x__SetDataCursor_parameters_t
{
	uint32_t ulCursor;
 } __PACKED;

struct MSXE312x__AnalogInputSetChannelConfiguration_parameters_t
{
	uint32_t ulChannel;
	uint32_t ulAcDc;
	uint32_t ulSingleDiff;
	uint32_t ulPolarity;
	uint32_t ulGain;
	uint32_t ulICP;
	uint32_t ulOption1;
	uint32_t ulOption2;
 } __PACKED;

struct MSXE312x__AnalogInputSetSamplingRate_parameters_t
{
	uint32_t ulTimeBase;
	uint32_t ulTimeBaseUnity;
	uint32_t ulSamplingRate;
	uint32_t ulOption1;
	uint32_t ulOption2;
 } __PACKED;

struct MSXE312x__AcquisitionAutoRefreshInitAndStart_parameters_t
{
	uint32_t ulChannelMask;
	uint32_t ulAverageValue;
	uint32_t ulRefreshTime;
	uint32_t ulRefreshTimeUnit;
	uint32_t ulTriggerMask;
	uint32_t ulTriggerMode;
	uint32_t ulHardwareTriggerEdge;
	uint32_t ulHardwareTriggerCount;
	uint32_t ulByTriggerNbrOfSeqToAcquire;
	uint32_t ulDataFormat;
	uint32_t ulForceStart;
	uint32_t ulOption1;
	uint32_t ulOption2;
	uint32_t ulOption3;
 } __PACKED;

struct MSXE312x__AcquisitionAutoRefreshStopAndRelease_parameters_t
{
	uint32_t ulOption1;
 } __PACKED;

struct MSXE312x__AcquisitionSequenceInitAndStart_parameters_t
{
	uint32_t ulNbrOfChannel;
	uint32_t ulChannelList[16];
	uint32_t ulAcquisitionTime;
	uint32_t ulAcquisitionTimeUnit;
	uint32_t ulNbrOfSequence;
	uint32_t ulNbrMaxSequenceToTransfer;
	uint32_t ulTriggerMask;
	uint32_t ulTriggerMode;
	uint32_t ulHardwareTriggerEdge;
	uint32_t ulHardwareTriggerCount;
	uint32_t ulByTriggerNbrOfSeqToAcquire;
	uint32_t ulDataFormat;
	uint32_t ulForceStart;
	uint32_t ulOption1;
	uint32_t ulOption2;
	uint32_t ulOption3;
 } __PACKED;

struct MSXE312x__AcquisitionSequenceStopAndRelease_parameters_t
{
	uint32_t ulOption01;
 } __PACKED;

struct MSXE312x__AnalogOutputWrite1Value_parameters_t
{
	uint32_t ulChannel;
	uint32_t ulOutputType;
	uint32_t ulPolarity;
	uint32_t ulTriggerMask;
	uint32_t ulTriggerEdgeSelection;
	uint32_t ulTriggerCount;
	uint32_t ulValue;
	uint32_t ulOption01;
	uint32_t ulOption02;
	uint32_t ulOption03;
 } __PACKED;

struct MSXE312x__AnalogOutputTriggerOutputs_parameters_t
{
	uint32_t ulOption01;
 } __PACKED;

struct MSXE312x__DigitalIOSetPortDirections_parameters_t
{
	uint32_t ulPort;
	uint32_t ulDirection;
	uint32_t ulOption1;
 } __PACKED;

struct MSXE312x__DigitalIOSetInputsFilterTime_parameters_t
{
	uint32_t ulFilterTime;
	uint32_t ulOption1;
 } __PACKED;

struct MSXE312x__DigitalIOEnableDisableInputsFilter_parameters_t
{
	uint32_t ulPort;
	uint32_t ulFilter;
	uint32_t ulOption1;
 } __PACKED;

struct MSXE312x__DigitalIORearmOutputsShortCircuit_parameters_t
{
	uint32_t ulOption1;
 } __PACKED;

struct MSXE312x__DigitalIOWriteChannel_parameters_t
{
	uint32_t ulChannel;
	uint32_t ulState;
	uint32_t ulOption1;
 } __PACKED;

struct MSXE312x__DigitalIOWritePort_parameters_t
{
	uint32_t ulPort;
	uint32_t ulState;
	uint32_t ulOption1;
 } __PACKED;

#ifdef WIN32
#pragma pack()
#endif // WIN32


/** <p>Change the active data cursor cursor</p>
*
* <p><b>Parameters:</b></p><ul>
* <p>@param[in] <b><VAR>ulCursor:</VAR></b> New cursor value </p>
* </ul>
*
* <p><b> Returns:</b></p><ul>
*
* @return <b>Possible return value on the remote system (read them with GetLastCommandStatus)</b>
* <ul>
* <li> 0: success \n
* <li> -1:  otherwise : internal error \n
* </ul>
*/
	
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE312x__SetDataCursor(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulCursor;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE312x__SetDataCursor(modbus,ulCursor,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE312x__SetDataCursor");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE312x__SetDataCursor\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE312x__SetDataCursor()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE312x__SetDataCursor OK\n");
	return 0;
}

*/

int modbus_call_MSXE312x__SetDataCursor(struct modbus * modbus,
	uint32_t ulCursor
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Analog input channel configuration</p>
* <p><b>Parameters</b></p>
* <ul>
* 	<li>@param[in] <b><VAR> ulChannel </VAR></b> Channel selection. 0 to 7</li>
* 	<li>@param[in] <b><VAR> ulAcDc </VAR></b> AC/DC coupling selection
*		<ul>
*			<li> 0 : DC</li>
*			<li> 1 : AC </li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulSingleDiff </VAR></b> Single/differential selection
*		<ul>
*			<li> 0 : Single</li>
*			<li> 1 : Differential</li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulPolarity </VAR></b> Polarity selection
*		<ul>
*			<li> 0 : Bipolar</li>
*			<li> 1 : Unipolar </li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulGain </VAR></b> Gain selection
*		<ul>
*			<li> 1 : Gain 1x</li>
*			<li> 10 : Gain 10x</li>
*			<li> 100 : Gain 100x</li>
*			<li> 1000 : Gain 1000x</li>
*		</ul>
*	</li>
*	<li>@param[in] <b><VAR> ulICP </VAR></b> ICP source
*		<ul>
*			<li> 0 : Disable the ICP source</li>
*			<li> 1 : Enable the ICP source </li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulOption1 </VAR></b> Reserved. Set to 0</li>
* 	<li>@param[in] <b><VAR> ulOption2 </VAR></b> Reserved. Set to 0</li>
* </ul>
* <p><b>Returns</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-2</b> Channel selection wrong</li>
*	<li><b>-3</b> AC/DC coupling selection wrong</li>
*	<li><b>-4</b> Single/differential selection wrong</li>
*	<li><b>-5</b> Polarity selection wrong</li>
*	<li><b>-6</b> Gain selection wrong</li>
*	<li><b>-7</b> ICP selection wrong</li>
*	<li><b>-8</b> ICP not available</li>
*	<li><b>-9</b> Acquisition in progress. Can not change the configuration</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
		
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE312x__AnalogInputSetChannelConfiguration(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulChannel;
	uint32_t ulAcDc;
	uint32_t ulSingleDiff;
	uint32_t ulPolarity;
	uint32_t ulGain;
	uint32_t ulICP;
	uint32_t ulOption1;
	uint32_t ulOption2;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE312x__AnalogInputSetChannelConfiguration(modbus,ulChannel,ulAcDc,ulSingleDiff,ulPolarity,ulGain,ulICP,ulOption1,ulOption2,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE312x__AnalogInputSetChannelConfiguration");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE312x__AnalogInputSetChannelConfiguration\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE312x__AnalogInputSetChannelConfiguration()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE312x__AnalogInputSetChannelConfiguration OK\n");
	return 0;
}

*/

int modbus_call_MSXE312x__AnalogInputSetChannelConfiguration(struct modbus * modbus,
	uint32_t ulChannel,
	uint32_t ulAcDc,
	uint32_t ulSingleDiff,
	uint32_t ulPolarity,
	uint32_t ulGain,
	uint32_t ulICP,
	uint32_t ulOption1,
	uint32_t ulOption2
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Sets the sampling rate (or the sampling period) for the analog inputs.</p>
* <ul>
* 	<li>If you select <b>5</b> for the parameter <b>ulTimeBaseUnity</b>, then this function sets the <b>sampling rate</b>, i.e. the number of samples per second.</li>
* 	<li>If you select <b>0</b> for the parameter <b>ulTimeBaseUnity</b>, then this function sets the <b>sampling period</b>, i.e. the time between two samples.</li>
* </ul>
*
* <p><b>Parameters</b></p>
* <ul>
* 	<li>@param[in] <b><VAR> ulTimeBase </VAR></b> Time base selection
*		<ul>
*			<li> 0 for 1MHz</li>
*			<li> 1 for 6.4MHz </li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulTimeBaseUnity </VAR></b> Unity
*		<ul>
*			<li> 0 for µs</li>
*			<li> 5 for Hz</li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulSamplingRate </VAR></b> Sampling rate or sampling period according to the selected unity</li>
* 	<li>@param[in] <b><VAR> ulOption1 </VAR></b> Reserved. Set to 0</li>
* 	<li>@param[in] <b><VAR> ulOption2 </VAR></b> Reserved. Set to 0</li>
* </ul>
* <p><b>Returns</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-2</b> Sampling rate time base selection wrong</li>
*	<li><b>-3</b> Sampling rate time base unity selection wrong</li>
*	<li><b>-4</b> Sampling rate selection wrong</li>
*	<li><b>-5</b> Acquisition in progress. Can not change the sampling rate</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
		
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE312x__AnalogInputSetSamplingRate(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulTimeBase;
	uint32_t ulTimeBaseUnity;
	uint32_t ulSamplingRate;
	uint32_t ulOption1;
	uint32_t ulOption2;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE312x__AnalogInputSetSamplingRate(modbus,ulTimeBase,ulTimeBaseUnity,ulSamplingRate,ulOption1,ulOption2,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE312x__AnalogInputSetSamplingRate");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE312x__AnalogInputSetSamplingRate\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE312x__AnalogInputSetSamplingRate()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE312x__AnalogInputSetSamplingRate OK\n");
	return 0;
}

*/

int modbus_call_MSXE312x__AnalogInputSetSamplingRate(struct modbus * modbus,
	uint32_t ulTimeBase,
	uint32_t ulTimeBaseUnity,
	uint32_t ulSamplingRate,
	uint32_t ulOption1,
	uint32_t ulOption2
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Initialise and start an auto refresh acquisition using provided configuration</p>
* <p><b>Parameters</b></p>
* <ul>
* 	<li>@param[in] <b><VAR> ulChannelMask </VAR></b> Mask of the channel to acquire by the auto refresh (1 bit = 1 Channel). 0 for all available acquisition channels </li>
* 	<li>@param[in] <b><VAR> ulAverageValue </VAR></b> Set the average value
*		<ul>
*			<li> 1 : not used</li>
*			<li> max value : 255</li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulRefreshTimeUnit </VAR></b> Refresh Time Unit
*		<ul>
*			<li> 0 : microsecond</li>
*			<li> 1 : millisecond</li>
*			<li> 2 : second </li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulRefreshTime </VAR></b> Refresh Time
*		<ul>
*			<li> range from min 10 to 65535 when the unit is the microsecond</li>
*			<li> range from min 1 to 65535 when the unit is the millisecond</li>
*			<li> range from min 1 to 65535 when the unit is the second</li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulTriggerMask </VAR></b> Define the source of the trigger
*		<ul>
*			<li> 0 : trigger disabled</li>
*			<li> 1 : Enable Hardware Digital Input Trigger</li>
*			<li> 2 : Enable Synchro Trigger </li>
*			<li> 3 : Enable Compare Trigger (only useful if your system has incremental counter input) </li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulTriggerMode </VAR></b> Define the trigger mode
*		<ul>
*			<li> 1 : One shot trigger</li>
*			<li> 2 : Sequence trigger </li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulHardwareTriggerEdge </VAR></b> Define the edge of the hardware trigger who generates a trigger action
*		<ul>
*			<li> 1 : rising edge (Only if hardware trigger selected)</li>
*			<li> 2 : falling edge (Only if hardware trigger selected)</li>
*			<li> 3 : Both front (Only if hardware trigger selected) </li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulHardwareTriggerCount </VAR></b> Define the number of trigger events before the action occur
*		<ul>
*			<li> 1 : all trigger event start the action</li>
*			<li> max value : 65535 </li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulByTriggerNbrOfSeqToAcquire </VAR></b> Define the number of sequence to acquire by each trigger event
*		<ul>
*			<li> 0 : continuous mode</li>
*			<li> 0 : number of sequence : (1..0xFFFFFFFF) </li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulDataFormat </VAR></b>
*		<ul>
*			<li> D0 : Absolute time stamp information
*				<ul>
*					<li> 0: no time stamp information</li>
*					<li> 1: time stamp information </li>
*				</ul>
*			</li>
*			<li> D1 : Relative time stamp information
*				<ul>
*					<li> 0: no time stamp information</li>
*					<li> 1: time stamp information </li>
*				</ul>
*			</li>
*			<li> D2 : Auto refresh counter information
*				<ul>
*					<li>  0 : No auto refresh counter information</li>
*					<li>  1 : Auto refresh counter information </li>
*				</ul>
*			</li>
*			<li> D3 : Hardware trigger information
*				<ul>
*					<li>  0 : No hardware trigger information required</li>
*					<li>  1 : Hardware trigger information required</li>
*				</ul>
*			</li>
*			<li> D4 : Data format
*				<ul>
*					<li> 0: Digital value</li>
*					<li> 1: Analog value </li>
*				</ul>
*			</li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulForceStart </VAR></b>
*		<ul>
*			<li> 0 : Function return a error if any acquisition already in progress</li>
*			<li> 1 : If any acquisition in progress then stop this </li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulOption1 </VAR></b> Reserved. Set to 0</li>
* 	<li>@param[in] <b><VAR> ulOption2 </VAR></b> Reserved. Set to 0</li>
* 	<li>@param[in] <b><VAR> ulOption3 </VAR></b> Reserved. Set to 0</li>
* </ul>
* <p><b> Returns:</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-2</b> Any acquisition already in progress</li>
*	<li><b>-3</b> Any selected channel not OK, call the diagnostic function for more information</li>
*	<li><b>-4</b> Channel Mask error</li>
*	<li><b>-5</b> Not available average value</li>
*	<li><b>-6</b> Not available refresh time unit</li>
*	<li><b>-7</b> The minimal refresh time is 1000 us</li>
*	<li><b>-8</b> The maximal refresh time is 65535</li>
*	<li><b>-9</b> Trigger mask not available</li>
*	<li><b>-10</b> Trigger mask : 2 different trigger source cannot be simultaneously be activated</li>
*	<li><b>-11</b> Trigger mode not available</li>
*	<li><b>-12</b> Trigger mask : 2 trigger mode cannot be simultaneously activated</li>
*	<li><b>-13</b> Hardware trigger : front definition error</li>
*	<li><b>-14</b> Hardware trigger count value not available</li>
*	<li><b>-15</b> Nbr of sequence to acquire by trigger mode not available</li>
*	<li><b>-16</b> Data format not available</li>
*	<li><b>-17</b> Selected channels combination not available</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
		
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE312x__AcquisitionAutoRefreshInitAndStart(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulChannelMask;
	uint32_t ulAverageValue;
	uint32_t ulRefreshTime;
	uint32_t ulRefreshTimeUnit;
	uint32_t ulTriggerMask;
	uint32_t ulTriggerMode;
	uint32_t ulHardwareTriggerEdge;
	uint32_t ulHardwareTriggerCount;
	uint32_t ulByTriggerNbrOfSeqToAcquire;
	uint32_t ulDataFormat;
	uint32_t ulForceStart;
	uint32_t ulOption1;
	uint32_t ulOption2;
	uint32_t ulOption3;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE312x__AcquisitionAutoRefreshInitAndStart(modbus,ulChannelMask,ulAverageValue,ulRefreshTime,ulRefreshTimeUnit,ulTriggerMask,ulTriggerMode,ulHardwareTriggerEdge,ulHardwareTriggerCount,ulByTriggerNbrOfSeqToAcquire,ulDataFormat,ulForceStart,ulOption1,ulOption2,ulOption3,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE312x__AcquisitionAutoRefreshInitAndStart");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE312x__AcquisitionAutoRefreshInitAndStart\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE312x__AcquisitionAutoRefreshInitAndStart()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE312x__AcquisitionAutoRefreshInitAndStart OK\n");
	return 0;
}

*/

int modbus_call_MSXE312x__AcquisitionAutoRefreshInitAndStart(struct modbus * modbus,
	uint32_t ulChannelMask,
	uint32_t ulAverageValue,
	uint32_t ulRefreshTime,
	uint32_t ulRefreshTimeUnit,
	uint32_t ulTriggerMask,
	uint32_t ulTriggerMode,
	uint32_t ulHardwareTriggerEdge,
	uint32_t ulHardwareTriggerCount,
	uint32_t ulByTriggerNbrOfSeqToAcquire,
	uint32_t ulDataFormat,
	uint32_t ulForceStart,
	uint32_t ulOption1,
	uint32_t ulOption2,
	uint32_t ulOption3
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p> Stops the current auto refresh acquisition</p>
* <p><b>Parameters</b></p>
* <ul>
* 	<li>@param[in] <b><VAR> ulOption1 </VAR></b> Reserved. Set to 0</li>
* </ul>
* <p><b> Returns:</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
		
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE312x__AcquisitionAutoRefreshStopAndRelease(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulOption1;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE312x__AcquisitionAutoRefreshStopAndRelease(modbus,ulOption1,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE312x__AcquisitionAutoRefreshStopAndRelease");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE312x__AcquisitionAutoRefreshStopAndRelease\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE312x__AcquisitionAutoRefreshStopAndRelease()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE312x__AcquisitionAutoRefreshStopAndRelease OK\n");
	return 0;
}

*/

int modbus_call_MSXE312x__AcquisitionAutoRefreshStopAndRelease(struct modbus * modbus,
	uint32_t ulOption1
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Initialise and start the sequence acquisition mode</p>
*<p><b>Parameters</b></p>
* <ul>
* 	<li>@param[in] <b><VAR> ulNbrOfChannel </VAR></b> Number of channel in the sequence</li>
* 	<li>@param[in] <b><VAR> psChannelList </VAR></b> List of the channel who compose the sequence.</li>
* 	<li>@param[in] <b><VAR> ulAcquisitionTime </VAR></b> Acquisition Time
*		<ul>
*			<li> range from min 10 to 65535 when the unit is the microsecond</li>
*			<li> range from min 1 to 65535 when the unit is the millisecond</li>
*			<li> range from min 1 to 65535 when the unit is the second </li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulAcquisitionTimeUnit </VAR></b> Acquisition Time Unit
*		<ul>
*			<li> 0 : us</li>
*			<li> 1 : ms</li>
*			<li> 2 : s </li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulNbrOfSequence </VAR></b> Number of sequence to acquire
*		<ul>
*			<li> 0 : continuous mode</li>
*			<li> Superior to 0 : number of sequence </li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulNbrMaxSequenceToTransfer </VAR></b> Max number of sequence to acquire before a data transfer. (from 1 to 65535)</li>
* 	<li>@param[in] <b><VAR> ulTriggerMask </VAR></b> Define the source of the trigger
*		<ul>
*			<li> 0 : trigger disabled</li>
*			<li> 1 : Enable Hardware Digital Input Trigger</li>
*			<li> 2 : Enable Synchro Trigger</li>
*			<li> 3 : Enable Compare Trigger (only useful if your system has incremental counter input)</li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulTriggerMode </VAR></b> Define the trigger mode
*		<ul>
*			<li> 1 : One shot trigger</li>
*			<li> 2 : Sequence trigger </li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulHardwareTriggerEdge </VAR></b> Define the edge of the hardware trigger who generate a trigger action
*		<ul>
*			<li> 1 : rising front (Only if hardware trigger selected)</li>
*			<li> 2 : falling front (Only if hardware trigger selected)</li>
*			<li> 3 : Both front (Only if hardware trigger selected) </li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulHardwareTriggerCount </VAR></b> Define the number of trigger events before the action occur
*		<ul>
*			<li> 1 : all trigger event start the action</li>
*			<li> max value : 65535 </li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulByTriggerNbrOfSeqToAcquire </VAR></b> define the number of sequence to acquire by each trigger event
*		<ul>
*			<li> 0 : continuous mode</li>
*			<li> Superior to 0 : number of sequence : (1..0xFFFFFFFF) </li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulDataFormat </VAR></b> Data format option
*		<ul>
*			<li> D0 : Absolute time stamp information
*				<ul>
*					<li> 0: no time stamp information</li>
*					<li> 1: time stamp information</li>
*				</ul>
*			</li>
*			<li> D1 : Relative time stamp information
*				<ul>
*					<li> 0: no time stamp information</li>
*					<li> 1: time stamp information </li>
*				</ul>
*			</li>
*			<li> D2 : Sequence counter information
*				<ul>
*					<li> 0 : No sequence counter information</li>
*					<li> 1 : Sequence counter information </li>
*				</ul>
*			</li>
*			<li> D3 : Hardware trigger information
*				<ul>
*					<li>  0 : No hardware trigger information required</li>
*					<li>  1 : Hardware trigger information required</li>
*				</ul>
*			</li>
*			<li> D4 : Data format
*				<ul>
*					<li> 0: Digital value</li>
*					<li> 1: Analog value </li>
*				</ul>
*			</li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulForceStart </VAR></b>
*		<ul>
*			<li> 0 : Function return a error if any acquisition already in progress</li>
*			<li> 1 : If any acquisition in progress then stop this </li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulOption1 </VAR></b> Reserved. Set to 0</li>
* 	<li>@param[in] <b><VAR> ulOption2 </VAR></b> Reserved. Set to 0</li>
* 	<li>@param[in] <b><VAR> ulOption3 </VAR></b> Reserved. Set to 0</li>
* </ul>
* <p><b> Returns:</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-2</b> Any acquisition already in progress</li>
*	<li><b>-3</b> The number of channel in the sequence is null or to high</li>
*	<li><b>-4</b> Channel index selection error</li>
*	<li><b>-5</b> Channel already selected</li>
*	<li><b>-6</b> Any selected channel not OK, call the diagnostic function for more information</li>
*	<li><b>-7</b> Not available acquisition time unit</li>
*	<li><b>-8</b> The minimal acquisition time is 1000 us !</li>
*	<li><b>-9</b> The maximal acquisition time is 65535 !</li>
*	<li><b>-10</b> Transfer sequence size error (1 to 4096) !</li>
*	<li><b>-11</b> The total number of sequences is not a multiple from number of sequences to transfer</li>
*	<li><b>-12</b> Trigger mask not available</li>
*	<li><b>-13</b> Trigger mask : 2 different trigger source cannot be simultaneously be activated</li>
*	<li><b>-14</b> Trigger mode not available</li>
*	<li><b>-15</b> Trigger mask : 2 trigger mode cannot be simultaneously be activated</li>
*	<li><b>-16</b> Hardware trigger : front definition error</li>
*	<li><b>-17</b> Hardware trigger count value not available</li>
*	<li><b>-18</b> Number of sequence to acquire by trigger mode not available</li>
*	<li><b>-19</b> Data format not available</li>
*	<li><b>-20</b> Selected channels combination not available</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
			
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE312x__AcquisitionSequenceInitAndStart(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulNbrOfChannel;
	uint32_t ulChannelList[16];
	uint32_t ulAcquisitionTime;
	uint32_t ulAcquisitionTimeUnit;
	uint32_t ulNbrOfSequence;
	uint32_t ulNbrMaxSequenceToTransfer;
	uint32_t ulTriggerMask;
	uint32_t ulTriggerMode;
	uint32_t ulHardwareTriggerEdge;
	uint32_t ulHardwareTriggerCount;
	uint32_t ulByTriggerNbrOfSeqToAcquire;
	uint32_t ulDataFormat;
	uint32_t ulForceStart;
	uint32_t ulOption1;
	uint32_t ulOption2;
	uint32_t ulOption3;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE312x__AcquisitionSequenceInitAndStart(modbus,ulNbrOfChannel,ulChannelList,ulAcquisitionTime,ulAcquisitionTimeUnit,ulNbrOfSequence,ulNbrMaxSequenceToTransfer,ulTriggerMask,ulTriggerMode,ulHardwareTriggerEdge,ulHardwareTriggerCount,ulByTriggerNbrOfSeqToAcquire,ulDataFormat,ulForceStart,ulOption1,ulOption2,ulOption3,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE312x__AcquisitionSequenceInitAndStart");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE312x__AcquisitionSequenceInitAndStart\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE312x__AcquisitionSequenceInitAndStart()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE312x__AcquisitionSequenceInitAndStart OK\n");
	return 0;
}

*/

int modbus_call_MSXE312x__AcquisitionSequenceInitAndStart(struct modbus * modbus,
	uint32_t ulNbrOfChannel,
	uint32_t ulChannelList[16],
	uint32_t ulAcquisitionTime,
	uint32_t ulAcquisitionTimeUnit,
	uint32_t ulNbrOfSequence,
	uint32_t ulNbrMaxSequenceToTransfer,
	uint32_t ulTriggerMask,
	uint32_t ulTriggerMode,
	uint32_t ulHardwareTriggerEdge,
	uint32_t ulHardwareTriggerCount,
	uint32_t ulByTriggerNbrOfSeqToAcquire,
	uint32_t ulDataFormat,
	uint32_t ulForceStart,
	uint32_t ulOption1,
	uint32_t ulOption2,
	uint32_t ulOption3
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Stop and release the sequence acquisition mode</p>
* <p><b>Parameters</b></p>
* <ul>
* 	<li>@param[in] <b><VAR> ulOption1 </VAR></b> Reserved. Set to 0</li>
* </ul>
* <p><b> Returns:</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-2</b> No sequence acquisition in progress</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
			
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE312x__AcquisitionSequenceStopAndRelease(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulOption01;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE312x__AcquisitionSequenceStopAndRelease(modbus,ulOption01,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE312x__AcquisitionSequenceStopAndRelease");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE312x__AcquisitionSequenceStopAndRelease\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE312x__AcquisitionSequenceStopAndRelease()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE312x__AcquisitionSequenceStopAndRelease OK\n");
	return 0;
}

*/

int modbus_call_MSXE312x__AcquisitionSequenceStopAndRelease(struct modbus * modbus,
	uint32_t ulOption01
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Set the value of an analog output</p>
* <p><b>Parameters</b></p>
* <ul>
* 	<li>@param[in] <b><VAR> ulChannel </VAR></b>  Index of the analog output (0 to AnalogOutputGetNumberOfChannels)</li>
* 	<li>@param[in] <b><VAR> ulOutputType </VAR></b> Type of the output (0 for Voltage, 1 for Current, 2 system default) </li>
* 	<li>@param[in] <b><VAR> ulPolarity </VAR></b> Polariy (0 for unipolar, 1 for bipolar)</li>
* 	<li>@param[in] <b><VAR> ulTriggerMask </VAR></b> Trigger to use to set the outputs (Mask of bits)
*		<ul>
*			<li> <b>0</b> no trigger: output directly updated after a call to this function</li>
*			<li> <b>Bit 0 = 1</b>: Hardware trigger used</li>
*			<li> <b>Bit 1 = 1</b>: Synchro trigger used</li>
*			<li> <b>Bit 2 = 1</b>: Software trigger used: output updated after a call to AnalogOutputTriggerOutputs </li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulTriggerEdgeSelection </VAR></b> Only used if you select the hardware trigger. Defines the detected edges (Mask of bits). The value cannot be null (if hardware trigger is selected).
*		<ul>
*			<li><b>Bit 0 = 1</b>: Rising edges are detected</li>
*			<li><b>Bit 1 = 1</b>: Falling edges are detected</li>
*			<li><b>Bit 0 = 1 and Bit 1 = 1</b>: Rising and falling edges are detected</li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulTriggerCount </VAR></b> Only used if you select the hardware trigger. Defines the number of hardware trigger to wait before updating the analog outputs. The value cannot be null (if hardware trigger is selected).</li>
* 	<li>@param[in] <b><VAR> ulValue </VAR></b> Value that you want to set (digital format)
*		<ul>
*			<li>If unipolar, range is from 0 to 0x7fff ( from 0V to +10V)</li>
*			<li>If bipolar, range is from 0 to 0xffff ( from -10V to +10V)</li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulOption0 </VAR></b> Reserved. Set to 0</li>
* 	<li>@param[in] <b><VAR> ulOption1 </VAR></b> Reserved. Set to 0</li>
* 	<li>@param[in] <b><VAR> ulOption2 </VAR></b> Reserved. Set to 0</li>
* </ul>
* <p><b>Returns</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-2</b> The PLD is not working</li>
*	<li><b>-3</b> The ulChannel parameter is wrong</li>
*	<li><b>-4</b> The ulOutputType parameter is wrong</li>
*	<li><b>-5</b> The ulPolarity parameter is wrong</li>
*	<li><b>-6</b> The ulTriggerMask parameter is wrong</li>
*	<li><b>-7</b> The ulValue parameter is wrong</li>
*	<li><b>-8</b> The ulTriggerEdgeSelection parameter is wrong</li>
*	<li><b>-9</b> The ulTriggerCount parameter is wrong</li>
*	<li><b>-10</b> Timeout while setting the value</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
		
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE312x__AnalogOutputWrite1Value(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulChannel;
	uint32_t ulOutputType;
	uint32_t ulPolarity;
	uint32_t ulTriggerMask;
	uint32_t ulTriggerEdgeSelection;
	uint32_t ulTriggerCount;
	uint32_t ulValue;
	uint32_t ulOption01;
	uint32_t ulOption02;
	uint32_t ulOption03;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE312x__AnalogOutputWrite1Value(modbus,ulChannel,ulOutputType,ulPolarity,ulTriggerMask,ulTriggerEdgeSelection,ulTriggerCount,ulValue,ulOption01,ulOption02,ulOption03,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE312x__AnalogOutputWrite1Value");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE312x__AnalogOutputWrite1Value\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE312x__AnalogOutputWrite1Value()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE312x__AnalogOutputWrite1Value OK\n");
	return 0;
}

*/

int modbus_call_MSXE312x__AnalogOutputWrite1Value(struct modbus * modbus,
	uint32_t ulChannel,
	uint32_t ulOutputType,
	uint32_t ulPolarity,
	uint32_t ulTriggerMask,
	uint32_t ulTriggerEdgeSelection,
	uint32_t ulTriggerCount,
	uint32_t ulValue,
	uint32_t ulOption01,
	uint32_t ulOption02,
	uint32_t ulOption03
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Trigger the analog outputs</p>
* <p>Set the voltage of the outputs to the last value written with AnalogOutputWrite1Value.</p>
* <p>Only useful if you called AnalogOutputWrite1Value with the bit 2 of the trigger mask set to 1 (software trigger)</p>
* <p>All the output values will be updated at the same time</p>
* <p><b>Parameters</b></p>
* <ul>
* 	<li>@param[in] <b><VAR> ulOption1 </VAR></b> Reserved. Set to 0</li>
* </ul>
* <p><b>Returns</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-2</b> The PLD is not working</li>
*	<li><b>-3</b> Timeout while triggering outputs</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
		
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE312x__AnalogOutputTriggerOutputs(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulOption01;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE312x__AnalogOutputTriggerOutputs(modbus,ulOption01,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE312x__AnalogOutputTriggerOutputs");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE312x__AnalogOutputTriggerOutputs\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE312x__AnalogOutputTriggerOutputs()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE312x__AnalogOutputTriggerOutputs OK\n");
	return 0;
}

*/

int modbus_call_MSXE312x__AnalogOutputTriggerOutputs(struct modbus * modbus,
	uint32_t ulOption01
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p> Write the current digital I/O direction for the selected port.</p>
* <p><b>Parameters</b></p>
* <ul>
* 	<li>@param[in] <b> <VAR>ulPort </VAR> </b> Selected digital I/O port (0 to MSXE312x__DigitalIOGetNumberOfPorts).</li>
* 	<li>@param[in] <b> <VAR>ulDirection </VAR> </b> Digital I/O direction. Each bit indicates if the channel is used as an input or an output. (0: input, 1: output)</li>
* 	<li>@param[in] <b> <VAR>ulOption1 </VAR> </b> Reserved. Set to 0</li>
* </ul>
* <p><b>Returns</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-2</b> The ulPort parameter is wrong</li>
*	<li><b>-3</b> The ulDirection parameter is wrong</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
	
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE312x__DigitalIOSetPortDirections(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulPort;
	uint32_t ulDirection;
	uint32_t ulOption1;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE312x__DigitalIOSetPortDirections(modbus,ulPort,ulDirection,ulOption1,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE312x__DigitalIOSetPortDirections");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE312x__DigitalIOSetPortDirections\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE312x__DigitalIOSetPortDirections()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE312x__DigitalIOSetPortDirections OK\n");
	return 0;
}

*/

int modbus_call_MSXE312x__DigitalIOSetPortDirections(struct modbus * modbus,
	uint32_t ulPort,
	uint32_t ulDirection,
	uint32_t ulOption1
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Sets the filter time for the digital inputs in steps of 250 ns (max value: 16777215)</p>
* <p><b>Parameters</b></p>
* <ul>
* 	<li>@param[in] <b> <VAR>ulFilterTime </VAR> </b> Filter time for the digital inputs in steps of 250 ns (max value: 16777215)
*		<ul>
* 			<li><b>0</b>: Disable the filter</li>
* 			<li><b>1</b>: Sets the filter time to 250 ns </li>
* 			<li><b>2</b>: Sets the filter time to 500 ns </li>
* 			<li>...</li>
* 			<li><b>16777215</b>: Sets the filter time to 4 s</li>
* 		</ul>
*	</li>
* 	<li>@param[in] <b> <VAR>ulOption1 </VAR> </b> Reserved. Set to 0</li>
* </ul>
* <p><b>Returns</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-2</b> The ulFilterTime parameter is wrong</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
	
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE312x__DigitalIOSetInputsFilterTime(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulFilterTime;
	uint32_t ulOption1;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE312x__DigitalIOSetInputsFilterTime(modbus,ulFilterTime,ulOption1,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE312x__DigitalIOSetInputsFilterTime");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE312x__DigitalIOSetInputsFilterTime\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE312x__DigitalIOSetInputsFilterTime()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE312x__DigitalIOSetInputsFilterTime OK\n");
	return 0;
}

*/

int modbus_call_MSXE312x__DigitalIOSetInputsFilterTime(struct modbus * modbus,
	uint32_t ulFilterTime,
	uint32_t ulOption1
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Enables/disables the digital input filter for the selected port.</p>
* <p><b>Parameters</b></p>
* <ul>
* 	<li>@param[in] <b> <VAR>ulPort </VAR> </b> Selected digital I/O port (0 to MSXE312x__DigitalIOGetNumberOfPorts).</li>
* 	<li>@param[in] <b> <VAR>ulFilter </VAR> </b> Digital input filter selection. Each bit indicates if the filter is enabled on the input. (0: disabled, 1: enabled)</li>
* 	<li>@param[in] <b> <VAR>ulOption1 </VAR> </b> Reserved. Set to 0</li>
* </ul>
* <p><b>Returns</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-2</b> The ulPort parameter is wrong</li>
*	<li><b>-3</b> The ulFilterTime parameter is wrong</li>
*	<li><b>-4</b> Any selected input is not an input or a bidirectional channel</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
	
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE312x__DigitalIOEnableDisableInputsFilter(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulPort;
	uint32_t ulFilter;
	uint32_t ulOption1;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE312x__DigitalIOEnableDisableInputsFilter(modbus,ulPort,ulFilter,ulOption1,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE312x__DigitalIOEnableDisableInputsFilter");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE312x__DigitalIOEnableDisableInputsFilter\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE312x__DigitalIOEnableDisableInputsFilter()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE312x__DigitalIOEnableDisableInputsFilter OK\n");
	return 0;
}

*/

int modbus_call_MSXE312x__DigitalIOEnableDisableInputsFilter(struct modbus * modbus,
	uint32_t ulPort,
	uint32_t ulFilter,
	uint32_t ulOption1
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Rearm the digital outputs short circuit.</p>
* <p>Please use only this function if you detected a short circuit using the function MSXE312x__DigitalIOTestOutputsShortCircuit.</p>
* <p><b>Parameters</b></p>
* <ul>
* 	<li>@param[in] <b> <VAR>ulOption1 </VAR> </b> Reserved. Set to 0</li>
* </ul>
* <p><b>Returns</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
	
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE312x__DigitalIORearmOutputsShortCircuit(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulOption1;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE312x__DigitalIORearmOutputsShortCircuit(modbus,ulOption1,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE312x__DigitalIORearmOutputsShortCircuit");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE312x__DigitalIORearmOutputsShortCircuit\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE312x__DigitalIORearmOutputsShortCircuit()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE312x__DigitalIORearmOutputsShortCircuit OK\n");
	return 0;
}

*/

int modbus_call_MSXE312x__DigitalIORearmOutputsShortCircuit(struct modbus * modbus,
	uint32_t ulOption1
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Set the selected digital output channel to on or off.</p>
* <p><b>Parameters</b></p>
* <ul>
* 	<li>@param[in] <b> <VAR>ulChannel </VAR> </b> Selected digital I/O channel (0 to MSXE312x__DigitalIOGetNumberOfChannels).</li>
* 	<li>@param[in] <b> <VAR>ulState </VAR> </b> Digital I/O channel state (0: off, 1: on)</li>
* 	<li>@param[in] <b> <VAR>ulOption1 </VAR> </b> Reserved. Set to 0</li>
* </ul>
* <p><b>Returns</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-2</b> The ulChannel parameter is wrong</li>
*	<li><b>-3</b> The ulState parameter is wrong</li>
*	<li><b>-4</b> The selected digital I/O is not an output</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
	
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE312x__DigitalIOWriteChannel(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulChannel;
	uint32_t ulState;
	uint32_t ulOption1;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE312x__DigitalIOWriteChannel(modbus,ulChannel,ulState,ulOption1,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE312x__DigitalIOWriteChannel");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE312x__DigitalIOWriteChannel\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE312x__DigitalIOWriteChannel()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE312x__DigitalIOWriteChannel OK\n");
	return 0;
}

*/

int modbus_call_MSXE312x__DigitalIOWriteChannel(struct modbus * modbus,
	uint32_t ulChannel,
	uint32_t ulState,
	uint32_t ulOption1
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Write a value to the selected digital I/O port.</p>
* <p><b>Parameters</b></p>
* <ul>
* 	<li>@param[in] <b> <VAR>ulPort </VAR> </b> Selected digital I/O port (0 to MSXE312x__DigitalIOGetNumberOfPorts).</li>
* 	<li>@param[in] <b> <VAR>ulState </VAR> </b> Digital I/O state. Each bit set the state for one digital I/O channel (0: off, 1: on)</li>
* 	<li>@param[in] <b> <VAR>ulOption1 </VAR> </b> Reserved. Set to 0</li>
* </ul>
* <p><b>Returns</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-2</b> The ulPort parameter is wrong</li>
*	<li><b>-3</b> The ulState parameter is wrong</li>
*	<li><b>-4</b> Any digital I/O set to 1 is not an output channel</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
	
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE312x__DigitalIOWritePort(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulPort;
	uint32_t ulState;
	uint32_t ulOption1;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE312x__DigitalIOWritePort(modbus,ulPort,ulState,ulOption1,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE312x__DigitalIOWritePort");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE312x__DigitalIOWritePort\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE312x__DigitalIOWritePort()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE312x__DigitalIOWritePort OK\n");
	return 0;
}

*/

int modbus_call_MSXE312x__DigitalIOWritePort(struct modbus * modbus,
	uint32_t ulPort,
	uint32_t ulState,
	uint32_t ulOption1
, struct GetLastCommandStatus_parameters_t * CommandStatus);

#endif //_MODBUS_MSXE312X_CLIENT_DEFINITION_H_


