/* WARNING: this file is generated by modbus_server/Makefile.mk */
/* WARNING: modbus_server */
/** @file modbuscli.c MODBUS/TCP/UDP client sample for the MSXE312x
 *
 * FC16 queries are for setting things, FC3 for fetching values
 *
 * This code doesn't handle timeouts.
 */

#ifdef WIN32
	#include "../../Interface_Library/msxe312x_modbus_clientlib.h"
#else
	#include <msxe312x_modbus_clientlib.h>
#endif

#ifdef WIN32
	#include <windows.h>
	#define sleep Sleep
#else
	#include <unistd.h>
#endif

#include <modbusclient.h>
#include <commonclient.h>

#include <addidata_console.h>
#include <addidata_network.h>
#include <addidata_dataclient.h>

	uint32_t  ulNbrOfDigIOChannels     = 0;
	uint32_t  ulNbrOfDigIOPorts        = 0;
	uint32_t  ulAvDirectionInputs [4]  = {0, 0, 0, 0};
	uint32_t  ulAvDirectionOutputs [4] = {0, 0, 0, 0};

	uint32_t ulNbrOfAcquisitionChannels    = 0;
	uint32_t ulNbrOfSequence               = 100;

// Get the acquisition channels informatiom

int sample_MSXE312x__AcquisitionGetInformations (struct modbus * modbus)
{
	struct MSXE312x__AcquisitionGetNumberOfChannels_parameters_t ResponseGetChannels;
	struct MSXE312x__AcquisitionGetChannelsInfo_parameters_t     ResponseChannelInfo;
	int       iRet          = 0;
	uint32_t ulChannels     = 0;
	char      cType [7][20] = {"not available", "temperature", "pressure", "transducer", "analog input", "analog input ICP", "digital I/O port"};

	printf ("\nGet acquisition channels informations:\n");
	printf ("--------------------------------------\n");

	memset(&ResponseGetChannels,0,sizeof(ResponseGetChannels));
	memset(&ResponseChannelInfo,0,sizeof(ResponseChannelInfo));

	// Get the number of acquisition channels
	iRet = modbus_call_MSXE312x__AcquisitionGetNumberOfChannels(modbus, &ResponseGetChannels);

	if ( !handle_result_of_FC3_query(modbus, iRet, "modbus_call_MSXE312x__AcquisitionGetNumberOfChannels") )
	{
		ulNbrOfAcquisitionChannels = ResponseGetChannels.ulNumber;
		printf ("Number of availables acquisition channel(s) : %u\n", ulNbrOfAcquisitionChannels);

		// Get the channels info
		iRet = modbus_call_MSXE312x__AcquisitionGetChannelsInfo (modbus, &ResponseChannelInfo);

		if ( !handle_result_of_FC3_query(modbus, iRet, "modbus_call_MSXE312x__AcquisitionGetChannelsInfo") )
		{
			for (ulChannels = 0; ulChannels < ulNbrOfAcquisitionChannels; ulChannels++)
			{
				printf("Acquisition channel %2d connected to connector %u is a %s channel \n",ulChannels, ResponseChannelInfo.ulHwPosition[ulChannels], cType[ResponseChannelInfo.ulType[ulChannels]]);
			}
		}
		else
		{
			return (-1);
		}

		printf("\nPress a key to continue\n");
		fflush(stdout);
		addidata_console_wait_for_input();

		return (0);
	}

	return (-1);
}

// Analog input initialisation
int sample_MSXE312x__AnalogInputChannelsInitialisation(struct modbus * modbus)
{
	struct MSXE312x__AnalogInputGetNumberOfChannels_parameters_t   ResponseGetChannels;
	struct MSXE312x__AnalogInputGetChannelsType_parameters_t       ResponseAnalogInputsType;
	struct GetLastCommandStatus_parameters_t                                  ResponseSetConfiguration;
	struct GetLastCommandStatus_parameters_t                                  ResponseSetSamplingRate;
	char      cType[2][10] = {"V", "C"};
	char      cICP[2][20]  = {"not available", "available"};
	int       iRet         = 0;
	uint32_t ulChannels    = 0;

	printf ("\nAnalog input channel(s) initialisation:\n");
	printf ("---------------------------------------\n");

	memset(&ResponseGetChannels,0,sizeof(ResponseGetChannels));

	iRet = modbus_call_MSXE312x__AnalogInputGetNumberOfChannels(modbus, &ResponseGetChannels);

	if ( !handle_result_of_FC3_query(modbus, iRet, "modbus_call_MSXE312x__AnalogInputGetNumberOfChannels") )
	{
		iRet = modbus_call_MSXE312x__AnalogInputGetChannelsType(modbus, &ResponseAnalogInputsType);

		if ( !handle_result_of_FC3_query(modbus, iRet, "modbus_call_MSXE312x__AnalogInputGetChannelsType") )
		{
			for (ulChannels = 0; ulChannels < ResponseGetChannels.ulNumber; ulChannels ++)
			{
				printf("Analog input channel %d type : %s.\n  ICP %s.\n  Set to DC, differential, bipolar,  gain 1.\n",
				       ulChannels,
				       cType [ResponseAnalogInputsType.ulType[ulChannels]],
				       cICP [ResponseAnalogInputsType.ulICP[ulChannels]]);

				// Set the analog input configuration
				iRet = modbus_call_MSXE312x__AnalogInputSetChannelConfiguration (modbus, (unsigned long) ulChannels, 0, 1, 0, 1, 0, 0, 0, &ResponseSetConfiguration);

				if (handle_result_of_FC16_query(modbus, &ResponseSetConfiguration, iRet, "modbus_call_MSXE312x__AnalogInputSetChannelConfiguration"))
				{
					return (-1);
				}
			}

			printf ("Set the sampling rate to 10 micro s.\n\n");

			iRet = modbus_call_MSXE312x__AnalogInputSetSamplingRate (modbus, 0, 0, 10, 0, 0, &ResponseSetSamplingRate);

			if (handle_result_of_FC16_query(modbus, &ResponseSetSamplingRate, iRet, "modbus_call_MSXE312x__AnalogInputSetSamplingRate" ))
			{
				return (-1);
			}

			printf("\nPress a key to continue\n");
			fflush(stdout);
			addidata_console_wait_for_input();

			return (0);
		}
		else
		{
			return (-1);
		}
	}
	return (-1);
}

// Write an analog output
int sample_MSXE312x__AnalogOutputWriteOneValue(struct modbus * modbus)
{
	struct MSXE312x__AnalogOutputGetNumberOfChannels_parameters_t	ResponseGetChannels;
	struct GetLastCommandStatus_parameters_t									ResponseWrite1Value;
	int       iRet         = 0;
	uint32_t ulChannels    = 0;
	uint32_t ulValue	   = 0;

	printf ("\nAnalog output channel(s) write 1 value:\n");
	printf ("---------------------------------------\n");

	memset(&ResponseGetChannels,0,sizeof(ResponseGetChannels));

	iRet = modbus_call_MSXE312x__AnalogOutputGetNumberOfChannels(modbus, &ResponseGetChannels);

	if ( !handle_result_of_FC3_query(modbus, iRet, "modbus_call_MSXE312x__AnalogOutputGetNumberOfChannels") )
	{
		for (ulChannels = 0; ulChannels < ResponseGetChannels.ulNumber; ulChannels ++)
		{
			printf("Set channel %d to 0x%x \n", (int)ulChannels, (int)ulValue );
			// Set the output value
			iRet = modbus_call_MSXE312x__AnalogOutputWrite1Value (modbus, ulChannels, 0, 0, 0, 0, 0, ulValue, 0, 0, 0, &ResponseWrite1Value);

			if (handle_result_of_FC16_query(modbus, &ResponseWrite1Value, iRet, "modbus_call_MSXE312x__AnalogOutputWrite1Value"))
			{
				return (-1);
			}

			ulValue += (0x7fff / ResponseGetChannels.ulNumber);
		}

		printf("\nPress a key to continue\n");
		fflush(stdout);
		addidata_console_wait_for_input();

		return (0);
	}
	return (-1);
}

/**
 * Set the value of the analog outputs using a trigger
 */
int sample_MSXE312x__AnalogOutputTriggerOutputs(struct modbus * modbus)
{
	struct MSXE312x__AnalogOutputGetNumberOfChannels_parameters_t	ResponseGetChannels;
	struct GetLastCommandStatus_parameters_t									ResponseWrite1Value;
	struct GetLastCommandStatus_parameters_t									ResponseTriggerOutputs;
	int       iRet         = 0;
	uint32_t ulChannels    = 0;

	printf ("\nAnalog output channel(s) write 1 value using software trigger:\n");
	printf ("---------------------------------------\n");

	memset(&ResponseGetChannels,0,sizeof(ResponseGetChannels));

	/* get the number of analog outputs channels */
	iRet = modbus_call_MSXE312x__AnalogOutputGetNumberOfChannels(modbus, &ResponseGetChannels);
	if ( handle_result_of_FC3_query(modbus, iRet, "modbus_call_MSXE312x__AnalogOutputGetNumberOfChannels") )
		return -1;

	/* write the values using trigger mask of 4 (Bit 2 set to 0)*/
	for (ulChannels = 0; ulChannels < ResponseGetChannels.ulNumber; ulChannels ++)
	{
		printf("Set channel %d to 0x7fff \n", (int)ulChannels );
		/* set the value */
		iRet = modbus_call_MSXE312x__AnalogOutputWrite1Value (modbus, ulChannels, 0, 0, 4, 0, 0, 0x7fff, 0, 0, 0, &ResponseWrite1Value);
		if (handle_result_of_FC16_query(modbus, &ResponseWrite1Value, iRet, "modbus_call_MSXE312x__AnalogOutputWrite1Value"))
			return (-1);
	}

	printf("\nPress a key to generate the software trigger\n");
	fflush(stdout);
	addidata_console_wait_for_input();

	/* generate the software trigger */
	iRet = modbus_call_MSXE312x__AnalogOutputTriggerOutputs (modbus, 0, &ResponseTriggerOutputs);
	if (handle_result_of_FC16_query(modbus, &ResponseTriggerOutputs, iRet, "modbus_call_MSXE312x__AnalogOutputTriggerOutputs"))
		return (-1);

	printf("\nPress a key to continue\n");
	fflush(stdout);
	addidata_console_wait_for_input();

	return 0;
}

// Get the digital I/O initialisation
int sample_MSXE312x__DigitalIOChannelsGetInitialisation(struct modbus * modbus)
{
	struct MSXE312x__DigitalIOGetNumberOfChannels_parameters_t           ResponseGetChannels;
	struct MSXE312x__DigitalIOGetPortAvailableDirections_parameters_t    ResponseAvDirections;
	struct MSXE312x__DigitalIOGetPortDirections_parameters_t             ResponseCurDirections;
	struct MSXE312x__DigitalIOGetInputsFilterConfiguration_parameters_t  ResponseFilter;
	struct GetLastCommandStatus_parameters_t                                        GetResponse;
	char       cType[4][20]         = {"Error","Input", "Output", "Bidirectional"};
	char       cFilter[2][20]       = {"disabled", "enabled"};
	int        iRet                 = 0;
	uint32_t  ulChannels            = 0;
	uint32_t  ulTest                = 0;

	printf ("\nPress a key to get the digital I/O initialisation:\n");
	printf ("--------------------------------------------------\n\n");
	fflush(stdout);
	addidata_console_wait_for_input();

	memset(&ResponseGetChannels,0,sizeof(ResponseGetChannels));

	// Get the number of digital I/O channels
	iRet = modbus_call_MSXE312x__DigitalIOGetNumberOfChannels(modbus, &ResponseGetChannels);

	if ( !handle_result_of_FC3_query(modbus, iRet, "modbus_call_MSXE312x__DigitalIOGetNumberOfChannels") )
	{
		ulNbrOfDigIOChannels = ResponseGetChannels.ulNumber;
		ulNbrOfDigIOPorts    = ((ulNbrOfDigIOChannels / 32) + (((ulNbrOfDigIOChannels % 32) != 0) ? 1 : 0));

		for (ulChannels = 0; ulChannels < ulNbrOfDigIOChannels; ulChannels ++)
		{
			// Test if get informations
			if ((ulChannels % 32) == 0)
			{
				// Select the port
				iRet = modbus_call_MSXE312x__SetDataCursor (modbus, ulChannels / 32, &GetResponse);

				if (handle_result_of_FC16_query(modbus, &GetResponse, iRet, "modbus_call_MSXE312x__SetDataCursor" ))
				{
					return (-1);
				}

				// Get the available directions
				iRet = modbus_call_MSXE312x__DigitalIOGetPortAvailableDirections(modbus, &ResponseAvDirections);

				if ( handle_result_of_FC3_query(modbus, iRet, "modbus_call_MSXE312x__DigitalIOGetPortAvailableDirections") )
				{
					return (-1);
				}

				ulAvDirectionInputs  [ulChannels / 32] = ResponseAvDirections.ulInputs;
				ulAvDirectionOutputs [ulChannels / 32] = ResponseAvDirections.ulOutputs;

				// Get the current directions
				iRet = modbus_call_MSXE312x__DigitalIOGetPortDirections(modbus, &ResponseCurDirections);

				if ( handle_result_of_FC3_query(modbus, iRet, "modbus_call_MSXE312x__DigitalIOGetPortDirections") )
				{
					return (-1);
				}

				// Get the filter time and configuration
				iRet = modbus_call_MSXE312x__DigitalIOGetInputsFilterConfiguration(modbus, &ResponseFilter);

				if ( handle_result_of_FC3_query(modbus, iRet, "modbus_call_MSXE312x__DigitalIOGetInputsFilterConfiguration") )
				{
					return (-1);
				}
			}

			// Get the digital I/O type (input, output, bidirectional)
			ulTest = ((ResponseAvDirections.ulInputs >> (ulChannels % 32)) & 1) + (((ResponseAvDirections.ulOutputs >> (ulChannels % 32)) & 1) * 2);
			printf("Digital I/O channel %d type : %s.\n", ulChannels, cType [ulTest]);

			// Get the digital I/O configuration (input, output)
			ulTest = (ResponseCurDirections.ulDirection >> (ulChannels % 32)) & 1;
			printf("    Configured as: %s.\n", cType [ulTest + 1]);

			// Get the digital I/O filter configuration
			ulTest = (ResponseFilter.ulFilter >> (ulChannels % 32)) & 1;
			printf("    Filter time is %dns and %s for this channel.\n", ResponseFilter.ulFilterTime, cFilter [ulTest]);
		}

		printf("\nPress a key to continue\n");
		fflush(stdout);
		addidata_console_wait_for_input();

		return (0);
	}

	return (-1);
}

void vConvertToBinary (uint32_t ulDig, char * pcBianry)
{
	int i       = 0;
	int iOffset = 0;

	for (i = 31; i >= 0; i --)
	{
		pcBianry[(31 - i) + iOffset] = '0' + (char) ((ulDig >> i) & 1);

		if (((31 - i) % 4) == 3)
		{
			iOffset ++;
			if (i == 0)
			{
				pcBianry[(31 - i) + iOffset] = 0;
			}
			else
			{
				pcBianry[(31 - i) + iOffset] = ' ';
			}

		}
	}
}

// Digital I/O test
int sample_MSXE312x__DigitalIOChannelsTest(struct modbus * modbus)
{
	struct MSXE312x__DigitalIOReadChannel_parameters_t ResponseRdChannel;
	struct MSXE312x__DigitalIOReadPort_parameters_t    ResponseRdPort;
	struct GetLastCommandStatus_parameters_t                      GetResponse;
	char       cState[2][20]        = {"Low", "High"};
	char       cBianry[42]          = "";
	int        iRet                 = 0;
	int        iTests               = 0;
	uint32_t  ulWrChannels          = 0;
	uint32_t  ulRdChannels          = 0;
	uint32_t  ulPorts               = 0;
	uint32_t  ulRdState[4]          = {0, 0, 0, 0};
	uint32_t  ulWrState[4]          = {0, 0, 0, 0};

	for (ulPorts = 0; ulPorts < ulNbrOfDigIOPorts; ulPorts ++)
	{
		// Set all available digital I/O as outputs
		iRet = modbus_call_MSXE312x__DigitalIOSetPortDirections (modbus, ulPorts, ulAvDirectionOutputs[ulPorts], 0, &GetResponse);

		if (handle_result_of_FC16_query(modbus, &GetResponse, iRet, "modbus_call_MSXE312x__DigitalIOSetPortDirections" ))
		{
			return (-1);
		}

		// Enable the filter for all inputs
		iRet = modbus_call_MSXE312x__DigitalIOEnableDisableInputsFilter (modbus, ulPorts, ulAvDirectionInputs[ulPorts], 0, &GetResponse);

		if (handle_result_of_FC16_query(modbus, &GetResponse, iRet, "modbus_call_MSXE312x__DigitalIOEnableDisableInputsFilter" ))
		{
			return (-1);
		}
	}

	// Set the filter to 1kHz for the digital inputs
	iRet = modbus_call_MSXE312x__DigitalIOSetInputsFilterTime (modbus, 500000, 0, &GetResponse);

	if (handle_result_of_FC16_query(modbus, &GetResponse, iRet, "modbus_call_MSXE312x__DigitalIOSetInputsFilterTime" ))
	{
		return (-1);
	}

	printf ("\nPress a key to start the digital I/O channel test:\n");
	printf ("--------------------------------------------------\n\n");
	fflush(stdout);
	addidata_console_wait_for_input();

	for (iTests = 0; iTests < 2; iTests ++)
	{
		for (ulWrChannels = 0; ulWrChannels < ulNbrOfDigIOChannels; ulWrChannels ++)
		{
			//Test if a output channel
			if (((ulAvDirectionOutputs[ulWrChannels / 32] >> (ulWrChannels % 32)) & 1) == 1)
			{
				printf ("Set the channel %d %s\n", ulWrChannels, cState[(iTests + 1) % 2]);

				// Set the output high/low
				iRet = modbus_call_MSXE312x__DigitalIOWriteChannel (modbus, ulWrChannels, (iTests + 1) % 2, 0, &GetResponse);

				if (handle_result_of_FC16_query(modbus, &GetResponse, iRet, "modbus_call_MSXE312x__DigitalIOWriteChannel" ))
				{
					return (-1);
				}
			}

			memset (ulRdState, 0, sizeof (ulRdState));

			// Read all channels
			for (ulRdChannels = 0; ulRdChannels < ulNbrOfDigIOChannels; ulRdChannels ++)
			{
				// Select the channel
				iRet = modbus_call_MSXE312x__SetDataCursor (modbus, ulRdChannels, &GetResponse);

				if (handle_result_of_FC16_query(modbus, &GetResponse, iRet, "modbus_call_MSXE312x__SetDataCursor" ))
				{
					return (-1);
				}

				// Read the channel state
				iRet = modbus_call_MSXE312x__DigitalIOReadChannel(modbus, &ResponseRdChannel);

				if ( handle_result_of_FC3_query(modbus, iRet, "modbus_call_MSXE312x__DigitalIOReadChannel") )
				{
					return (-1);
				}

				// Save the state
				ulRdState[ulRdChannels / 32] = ulRdState[ulRdChannels / 32] | (ResponseRdChannel.ulState << (ulRdChannels % 32));
			}

			// Display the state
			for (ulPorts = 0; ulPorts < ulNbrOfDigIOPorts; ulPorts ++)
			{
				// Convert to binary
				vConvertToBinary (ulRdState[ulPorts], cBianry);
				printf ("Digital I/O port %d state : %08XHex\n  Binary: %s\n", ulPorts, ulRdState[ulPorts], cBianry);
			}

			sleep(1);
		}
	}

	printf ("\nPress a key to start the digital I/O port test:\n");
	printf ("-----------------------------------------------\n\n");
	fflush(stdout);
	addidata_console_wait_for_input();

	for (iTests = 0; iTests < 2; iTests ++)
	{
		for (ulWrChannels = 0; ulWrChannels < ulNbrOfDigIOChannels; ulWrChannels ++)
		{
			//Test if a output channel
			if (((ulAvDirectionOutputs[ulWrChannels / 32] >> (ulWrChannels % 32)) & 1) == 1)
			{
				printf ("Set the channel %d %s\n", ulWrChannels, cState[(iTests + 1) % 2]);
				ulWrState[ulWrChannels / 32] = (ulWrState[ulWrChannels / 32] & (~(1UL << (ulWrChannels % 32)))) | (((iTests + 1) % 2) << (ulWrChannels % 32));

				// Set the output high/low
				iRet = modbus_call_MSXE312x__DigitalIOWritePort (modbus, ulWrChannels / 32, ulWrState[ulWrChannels / 32], 0, &GetResponse);

				if (handle_result_of_FC16_query(modbus, &GetResponse, iRet, "modbus_call_MSXE312x__DigitalIOWritePort" ))
				{
					return (-1);
				}
			}

			memset (ulRdState, 0, sizeof (ulRdState));

			for (ulPorts = 0; ulPorts < ulNbrOfDigIOPorts; ulPorts ++)
			{
				// Select the port
				iRet = modbus_call_MSXE312x__SetDataCursor (modbus, ulPorts, &GetResponse);

				if (handle_result_of_FC16_query(modbus, &GetResponse, iRet, "modbus_call_MSXE312x__SetDataCursor" ))
				{
					return (-1);
				}

				// Read the port state
				iRet = modbus_call_MSXE312x__DigitalIOReadPort(modbus, &ResponseRdPort);

				if ( handle_result_of_FC3_query(modbus, iRet, "modbus_call_MSXE312x__DigitalIOReadPort") )
				{
					return (-1);
				}

				// Save the state
				ulRdState[ulPorts] = ResponseRdPort.ulState;
			}

			// Display the state
			for (ulPorts = 0; ulPorts < ulNbrOfDigIOPorts; ulPorts ++)
			{
				// Convert to binary
				vConvertToBinary (ulRdState[ulPorts], cBianry);
				printf ("Digital I/O port %d state : %08XHex.\n  Binary: %s\n", ulPorts, ulRdState[ulPorts], cBianry);
			}

			sleep(1);
		}
	}

	printf("\nPress a key to continue\n");
	fflush(stdout);
	addidata_console_wait_for_input();

	return (0);
}

// Digital I/O diagnostic
int sample_MSXE312x__DigitalIODiagnostic(struct modbus * modbus)
{
	struct MSXE312x__DigitalIOTestOutputsShortCircuit_parameters_t ResponseDiagnostic;
	struct GetLastCommandStatus_parameters_t                                  GetResponse;
	char       cBianry[42]  = "";
	int        iRet         = 0;
	uint32_t  ulChannels    = 0;
	uint32_t  ulPorts       = 0;
	uint32_t  ulSortCircuit = 0;

	printf ("\nPress a key to start the digital I/O diagnostic test:\n");
	printf ("-----------------------------------------------------\n\n");
	fflush(stdout);
	addidata_console_wait_for_input();

	for (ulPorts = 0; ulPorts < ulNbrOfDigIOPorts; ulPorts ++)
	{
		// Select the port
		iRet = modbus_call_MSXE312x__SetDataCursor (modbus, ulPorts, &GetResponse);

		if (handle_result_of_FC16_query(modbus, &GetResponse, iRet, "modbus_call_MSXE312x__SetDataCursor" ))
		{
			return (-1);
		}

		// Get the diagnostic
		iRet = modbus_call_MSXE312x__DigitalIOTestOutputsShortCircuit(modbus, &ResponseDiagnostic);

		if ( handle_result_of_FC3_query(modbus, iRet, "modbus_call_MSXE312x__DigitalIOTestOutputsShortCircuit") )
		{
			return (-1);
		}

		ulSortCircuit = ulSortCircuit | ResponseDiagnostic.ulState;

		// Convert to binary
		vConvertToBinary (ResponseDiagnostic.ulState, cBianry);
		printf ("Digital I/O port %d diagnostic : %08XHex\n  Binary: %s\n", ulPorts, ResponseDiagnostic.ulState, cBianry);

		// Test if diagnostic not OK
		if (ResponseDiagnostic.ulState != 0)
		{
			for (ulChannels = 0; ulChannels < 32; ulChannels ++)
			{
				if (((ResponseDiagnostic.ulState >> ulChannels) & 1) != 1)
				{
					printf ("Channel %d short circuited\n", ulChannels + (ulPorts * 32));
				}
			}
		}
	}

	// Test if any short circuit occur
	if (ulSortCircuit != 0)
	{
		printf("\nPress a key to rearm the digital I/O channels\n\n");
		fflush(stdout);
		addidata_console_wait_for_input();

		// Make a rearm
		iRet = modbus_call_MSXE312x__DigitalIORearmOutputsShortCircuit (modbus, 0, &GetResponse);

		if (handle_result_of_FC16_query(modbus, &GetResponse, iRet, "modbus_call_MSXE312x__DigitalIORearmOutputsShortCircuit" ))
		{
			return (-1);
		}

			sleep(1);

		for (ulPorts = 0; ulPorts < ulNbrOfDigIOPorts; ulPorts ++)
		{
			// Select the port
			iRet = modbus_call_MSXE312x__SetDataCursor (modbus, ulPorts, &GetResponse);

			if (handle_result_of_FC16_query(modbus, &GetResponse, iRet, "modbus_call_MSXE312x__SetDataCursor" ))
			{
				return (-1);
			}

			// Get the diagnostic
			iRet = modbus_call_MSXE312x__DigitalIOTestOutputsShortCircuit(modbus, &ResponseDiagnostic);

			if ( handle_result_of_FC3_query(modbus, iRet, "modbus_call_MSXE312x__DigitalIOTestOutputsShortCircuit") )
			{
				return (-1);
			}

			// Convert to binary
			vConvertToBinary (ResponseDiagnostic.ulState, cBianry);
			printf ("Digital I/O port %d diagnostic : %08XHex\n  Binary: %s\n", ulPorts, ResponseDiagnostic.ulState, cBianry);

			// Test if diagnostic not OK
			if (ResponseDiagnostic.ulState != 0)
			{
				for (ulChannels = 0; ulChannels < 32; ulChannels ++)
				{
					if (((ResponseDiagnostic.ulState >> ulChannels) & 1) != 1)
					{
						printf ("Channel %d short circuited\n", ulChannels + (ulPorts * 32));
					}
				}
			}
		}
	}

	printf("\nPress a key to continue\n");
	fflush(stdout);
	addidata_console_wait_for_input();

	return (0);
}

// Auto refresh start
int sample_MSXE312x__AcquisitionAutoRefreshInitAndStart (struct modbus * modbus)
{
	struct GetLastCommandStatus_parameters_t Response;
	int      iRet                         = 0;
	uint32_t ulChannelMask                = (1 << ulNbrOfAcquisitionChannels) - 1;
	uint32_t ulAverageValue               = 1;
	uint32_t ulRefreshTime                = 200;
	uint32_t ulRefreshTimeUnit            = 1;
	uint32_t ulTriggerMask                = 0;
	uint32_t ulTriggerMode                = 0;
	uint32_t ulHardwareTriggerEdge        = 0;
	uint32_t ulHardwareTriggerCount       = 0;
	uint32_t ulByTriggerNbrOfSeqToAcquire = 0;
	uint32_t ulDataFormat                 = 0x1D;
	uint32_t ulForceStart                 = 1;
	uint32_t ulOption1                    = 0;
	uint32_t ulOption2                    = 0;
	uint32_t ulOption3                    = 0;

	printf("\nPress a key to start the auto refresh acquisition.\n");
	printf("--------------------------------------------------\n");
	fflush(stdout);
	addidata_console_wait_for_input();

	printf ("\nAuto refresh acquistion initialisation and start:\n");
	printf ("-------------------------------------------------\n");

	printf ("Channel mask                : %04X Hex\n", ulChannelMask);
	printf ("Average value               : %u\n",       ulAverageValue);
	printf ("Refresh time                : %u\n",       ulRefreshTime);
	printf ("Refresh time unit           : %u\n",       ulRefreshTimeUnit);
	printf ("Trigger mask                : %X Hex\n",   ulTriggerMask);
	printf ("Trigger mode                : %X Hex\n",   ulTriggerMode);
	printf ("HW trigger edge             : %u\n",       ulHardwareTriggerEdge);
	printf ("HW trigger count            : %u\n",       ulHardwareTriggerCount);
	printf ("HW trigger seq. to acquire  : %u\n",       ulByTriggerNbrOfSeqToAcquire);
	printf ("Data format                 : %X Hex\n",   ulDataFormat);

	iRet = modbus_call_MSXE312x__AcquisitionAutoRefreshInitAndStart (modbus,
	                                                                            ulChannelMask,
	                                                                            ulAverageValue,
	                                                                            ulRefreshTime,
	                                                                            ulRefreshTimeUnit,
	                                                                            ulTriggerMask,
	                                                                            ulTriggerMode,
	                                                                            ulHardwareTriggerEdge,
	                                                                            ulHardwareTriggerCount,
	                                                                            ulByTriggerNbrOfSeqToAcquire,
	                                                                            ulDataFormat,
	                                                                            ulForceStart,
	                                                                            ulOption1,
	                                                                            ulOption2,
	                                                                            ulOption3,
	                                                                            &Response);

	if (!iRet)
	{
		printf ("OK\n");
	}

	//Return value check
	return handle_result_of_FC16_query(modbus, &Response, iRet, "modbus_call_MSXE312x__AcquisitionAutoRefreshInitAndStart" );
}

// Auto refresh read
int sample_MSXE312x__AcquisitionAutoRefreshGetBlockingValues(struct modbus * modbus)
{
	struct MSXE312x__AcquisitionAutoRefreshGetBlockingValues_parameters_t Response;
	int       iRet      = 0;
	uint32_t ulChannels = 0;

	memset(&Response,0,sizeof(Response));

	iRet = modbus_call_MSXE312x__AcquisitionAutoRefreshGetBlockingValues(modbus, &Response);

	if ( !handle_result_of_FC3_query(modbus, iRet, "modbus_call_MSXE312x__AcquisitionAutoRefreshGetBlockingValues") )
	{
		printf("Counter: %10u\ts: %10u\tmicro s:%6u\n",Response.ulCounterValue,Response.ulTimeStampHigh, Response.ulTimeStampLow);
		{
			for (ulChannels = 0; ulChannels < ulNbrOfAcquisitionChannels; ulChannels ++)
			{
	        		printf("\tChannel %d = %f\n", ulChannels, Response.fValues[ulChannels]);
			}
		}
		return 0;
	}
	return -1;
}

// Auto refresh release
int sample_MSXE312x__AcquisitionAutoRefreshStopAndRelease (struct modbus * modbus)
{
	struct GetLastCommandStatus_parameters_t Response;
	int      iRet      = 0;
	uint32_t ulOption1 = 0;

	printf ("\nStop and release the auto refresh acquisition:\n");
	printf ("----------------------------------------------\n");

	iRet = modbus_call_MSXE312x__AcquisitionAutoRefreshStopAndRelease (modbus, ulOption1, &Response);

	if (!iRet)
	{
		printf ("OK\n");
	}

	//Return value check
	return handle_result_of_FC16_query(modbus, &Response, iRet, "modbus_call_MSXE312x__AcquisitionAutoRefreshStopAndRelease" );
}

// Auto refresh get configuration
int sample_MSXE312x__AcquisitionAutoRefreshGetConfiguration (struct modbus * modbus)
{
	struct MSXE312x__AcquisitionAutoRefreshGetConfiguration_parameters_t Response;
	int iRet = 0;

	memset(&Response,0,sizeof(Response));

	printf ("\nLast auto refresh acquisition configuration:\n");
	printf ("--------------------------------------------\n");

	iRet = modbus_call_MSXE312x__AcquisitionAutoRefreshGetConfiguration(modbus, &Response);

	if ( !handle_result_of_FC3_query(modbus, iRet, "modbus_call_MSXE312x__AcquisitionAutoRefreshGetConfiguration") )
	{
		printf ("Channel mask                : %04X Hex\n", Response.ulChannelMask);
		printf ("Average value               : %u\n",       Response.ulAverageValue);
		printf ("Refresh time                : %u\n",       Response.ulRefreshTime);
		printf ("Refresh time unit           : %u\n",       Response.ulRefreshTimeUnit);
		printf ("Trigger mask                : %X Hex\n",   Response.ulTriggerMask);
		printf ("Trigger mode                : %X Hex\n",   Response.ulTriggerMode);
		printf ("HW trigger edge             : %u\n",       Response.ulHardwareTriggerEdge);
		printf ("HW trigger count            : %u\n",       Response.ulHardwareTriggerCount);
		printf ("HW trigger seq. to acquire  : %u\n",       Response.ulByTriggerNbrOfSeqToAcquire);
		printf ("Data format                 : %X Hex\n",   Response.ulDataFormat);
		printf ("Running                     : %u\n",       Response.ulRunning);

		printf("\nPress a key to continue\n");
		fflush(stdout);
		addidata_console_wait_for_input();

		return 0;
	}
	return -1;
}

// Sequence start
int sample_MSXE312x__AcquisitionSequenceInitAndStart (struct modbus * modbus)
{
	struct GetLastCommandStatus_parameters_t Response;
	int      iRet                         = 0;
	uint32_t ulChannels                   = 0;
	uint32_t ulNbrOfChannel               = ulNbrOfAcquisitionChannels;
	uint32_t ulChannelList [16];
	uint32_t ulAcquisitionTime            = 10 * 2;
	uint32_t ulAcquisitionTimeUnit        = 0;
	uint32_t ulNbrMaxSequenceToTransfer   = ((ulNbrOfSequence / 10 > 0) ? ulNbrOfSequence / 10 : 1);
	uint32_t ulTriggerMask                = 0;
	uint32_t ulTriggerMode                = 0;
	uint32_t ulHardwareTriggerEdge        = 0;
	uint32_t ulHardwareTriggerCount       = 0;
	uint32_t ulByTriggerNbrOfSeqToAcquire = 0;
	uint32_t ulDataFormat                 = 0x1D;
	uint32_t ulForceStart                 = 1;
	uint32_t ulOption1                    = 0;
	uint32_t ulOption2                    = 0;
	uint32_t ulOption3                    = 0;

	printf ("\nSequence acquistion initialisation and start:\n");
	printf ("---------------------------------------------\n");

	printf ("Number of selected channels     : %u\n",       ulNbrOfChannel);
	printf ("Acquisition time                : %u\n",       ulAcquisitionTime);
	printf ("Acquisition time unit           : %u\n",       ulAcquisitionTimeUnit);
	printf ("Number of sequences             : %u\n",       ulNbrOfSequence);
	printf ("Number of sequences to transfer : %u\n",       ulNbrMaxSequenceToTransfer);
	printf ("Trigger mask                    : %X Hex\n",   ulTriggerMask);
	printf ("Trigger mode                    : %X Hex\n",   ulTriggerMode);
	printf ("HW trigger edge                 : %u\n",       ulHardwareTriggerEdge);
	printf ("HW trigger count                : %u\n",       ulHardwareTriggerCount);
	printf ("HW trigger seq. to acquire      : %u\n",       ulByTriggerNbrOfSeqToAcquire);
	printf ("Data format                     : %X Hex\n\n", ulDataFormat);

	for (ulChannels = 0; ulChannels < ulNbrOfChannel; ulChannels ++)
	{
		ulChannelList[ulChannels] = ulChannels;
	}

	iRet = modbus_call_MSXE312x__AcquisitionSequenceInitAndStart (modbus,
	                                                                         ulNbrOfChannel,
	                                                                         ulChannelList,
	                                                                         ulAcquisitionTime,
	                                                                         ulAcquisitionTimeUnit,
	                                                                         ulNbrOfSequence,
	                                                                         ulNbrMaxSequenceToTransfer,
	                                                                         ulTriggerMask,
	                                                                         ulTriggerMode,
	                                                                         ulHardwareTriggerEdge,
	                                                                         ulHardwareTriggerCount,
	                                                                         ulByTriggerNbrOfSeqToAcquire,
	                                                                         ulDataFormat,
	                                                                         ulForceStart,
	                                                                         ulOption1,
	                                                                         ulOption2,
	                                                                         ulOption3,
	                                                                         &Response);

	//Return value check
	return handle_result_of_FC16_query(modbus, &Response, iRet, "modbus_call_MSXE312x__AcquisitionSequenceInitAndStart" );
}

// Sequence release
int sample_MSXE312x__AcquisitionSequenceStopAndRelease (struct modbus * modbus)
{
	struct GetLastCommandStatus_parameters_t Response;
	int      iRet      = 0;
	uint32_t ulOption1 = 0;

	printf ("\nStop and release the sequence acquistion:\n");
	printf ("-----------------------------------------\n");

	iRet = modbus_call_MSXE312x__AcquisitionSequenceStopAndRelease (modbus, ulOption1, &Response);

	if (!iRet)
	{
		printf ("OK\n");
	}

	//Return value check
	return handle_result_of_FC16_query(modbus, &Response, iRet, "modbus_call_MSXE312x__AcquisitionSequenceStopAndRelease" );
}

// Auto refresh get configuration
int sample_MSXE312x__AcquisitionSequenceGetConfiguration (struct modbus * modbus)
{
	struct MSXE312x__AcquisitionSequenceGetConfiguration_parameters_t Response;
	int iRet = 0;

	memset(&Response,0,sizeof(Response));

	printf ("\nLast sequence acquisition configuration:\n");
	printf ("----------------------------------------\n");

	iRet = modbus_call_MSXE312x__AcquisitionSequenceGetConfiguration(modbus, &Response);

	if ( !handle_result_of_FC3_query(modbus, iRet, "modbus_call_MSXE312x__AcquisitionSequenceGetConfiguration") )
	{
		printf ("Number of selected channels     : %u\n",       Response.ulNbrOfChannel);
		printf ("Acquisition time                : %u\n",       Response.ulAcquisitionTime);
		printf ("Acquisition time unit           : %u\n",       Response.ulAcquisitionTimeUnit);
		printf ("Number of sequences             : %u\n",       Response.ulNbrOfSequence);
		printf ("Number of sequences to transfer : %u\n",       Response.ulNbrMaxSequenceToTransfer);
		printf ("Trigger mask                    : %X Hex\n",   Response.ulTriggerMask);
		printf ("Trigger mode                    : %X Hex\n",   Response.ulTriggerMode);
		printf ("HW trigger edge                 : %u\n",       Response.ulHardwareTriggerEdge);
		printf ("HW trigger count                : %u\n",       Response.ulHardwareTriggerCount);
		printf ("HW trigger seq. to acquire      : %u\n",       Response.ulByTriggerNbrOfSeqToAcquire);
		printf ("Data format                     : %X Hex\n",   Response.ulDataFormat);
		printf ("Running                         : %u\n",       Response.ulRunning);

		printf("\nPress a key to continue\n");
		fflush(stdout);
		addidata_console_wait_for_input();

		return 0;
	}
	return -1;
}

//---------------------------------------------------------------------------------
static void usage(char* name)
{
	printf("%s ADDRESS tcp|udp\n",name);
}

//---------------------------------------------------------------------------------

int main(int argc, char** argv)
{
	struct modbus modbus;
	int contype = SOCK_DGRAM;
	int       iFd = 0;
	uint32_t ulDatas[16 + 4];
	float*   pfDatas      = (float *) &ulDatas[4];
	uint32_t ulChannels   = 0;
	uint32_t ulCount      = 0;
	uint32_t ulFrameCount = 0;

	if (argc != 3)
	{
		usage(argv[0]);
		exit(1);
	}

	if (0 == strcmp(argv[2],"tcp"))
	{
		contype=SOCK_STREAM;
	}
	else if(0 == strcmp(argv[2],"udp"))
	{
		contype=SOCK_DGRAM;
	}
	else
	{
		usage(argv[0]);
		exit(1);
	}

	modbus_init(&modbus);

	switch( modbus_connect(&modbus, argv[1], contype, 0) )
	{
		case 0: /* success */
			break;
		case -1: /* system error */
			addidata_network_perror("modbus_connect");
			exit(1);
		case -2: /* parameter is incorrect */
			printf("modbus_connect: incorrect parameter\n");
			exit(1);
		case -3: /* incorrect address */
			printf("incorrect address\n");
			exit(1);
	}

	// Get the digital I/O initialisation
	assert( sample_MSXE312x__DigitalIOChannelsGetInitialisation(&modbus) == 0);

	// Digital I/O diagnostic
	assert( sample_MSXE312x__DigitalIODiagnostic(&modbus) == 0);

	// Test the digital I/O
	assert( sample_MSXE312x__DigitalIOChannelsTest(&modbus) == 0);

	// Digital I/O diagnostic
	assert( sample_MSXE312x__DigitalIODiagnostic(&modbus) == 0);

	// Get the digital I/O initialisation
	assert( sample_MSXE312x__DigitalIOChannelsGetInitialisation(&modbus) == 0);

	assert( sample_MSXE312x__AcquisitionGetInformations(&modbus) == 0);

	// Analog input initialisation

	assert( sample_MSXE312x__AnalogInputChannelsInitialisation(&modbus) == 0);

	// Write an analog output
	assert( sample_MSXE312x__AnalogOutputWriteOneValue(&modbus) == 0);
	assert( sample_MSXE312x__AnalogOutputTriggerOutputs(&modbus) == 0);

	/* autorefresh */
	assert( sample_MSXE312x__AcquisitionAutoRefreshInitAndStart(&modbus) == 0);
	{
		int i;
		for(i=0;i<100;i++)
		{
			assert( sample_MSXE312x__AcquisitionAutoRefreshGetBlockingValues(&modbus) == 0);
		}
	}

	assert( sample_MSXE312x__AcquisitionAutoRefreshStopAndRelease(&modbus) == 0);

	assert( sample_MSXE312x__AcquisitionAutoRefreshGetConfiguration(&modbus) == 0);

	printf("\nPress a key to start the sequence acquisition.\n");
	printf("----------------------------------------------\n");
	fflush(stdout);
	addidata_console_wait_for_input();

	/* connect to data server */
	switch(addidata_dataclient_tcp_connect(argv[1], 0, &iFd))
	{
		case 0: /* OK */
			break;
		case -1:
			addidata_network_perror("socket");
			exit(1);
		case -2:
			addidata_network_perror("connect");
			exit(1);
		case -3:
			printf("error while parsing address\n");
			exit(1);
		case -4:
			addidata_network_perror("WSACleanup() failed");
			exit(1);
	}

	/* sequence */
	assert( sample_MSXE312x__AcquisitionSequenceInitAndStart(&modbus) == 0);

	ulCount = ulNbrOfAcquisitionChannels + 4;

	for(ulFrameCount=0; ulFrameCount < ulNbrOfSequence; ulFrameCount++)
	{
		if( -1 == addidata_dataclient_recvall(iFd, ulDatas, (int) ulCount) )
		{
			addidata_network_perror("fetch");
			assert( sample_MSXE312x__AcquisitionSequenceStopAndRelease(&modbus) == 0);
			exit(1);
		}

		printf("Counter: %10u\ts: %10u\tmicro s:%6u\tHW trigger :%u\n",ulDatas[2],ulDatas[0],ulDatas[1],ulDatas[3]);
		{
			for (ulChannels = 0; ulChannels < (ulCount - 4); ulChannels ++)
			{
				printf("\tChannel %d = %f\n", ulChannels, pfDatas[ulChannels]);
			}
		}
	}

	addidata_dataclient_disconnect(iFd);

	assert( sample_MSXE312x__AcquisitionSequenceStopAndRelease(&modbus) == 0);

	assert( sample_MSXE312x__AcquisitionSequenceGetConfiguration(&modbus) == 0);

	printf("\nPress a key to end this sample\n");
	fflush(stdout);
	addidata_console_wait_for_input();

	return 0;
}
/* WARNING: this file is generated by modbus_server/Makefile.mk */
