using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Collections;


namespace Initialisation
{
    public partial class FInitialisation : Form
    {
        // Global Variable
        private MXCommon_WebReference.MXCommon MX_Common;
        private MSXExxxx_WebReference.MSXExxxx MSXExxxx;
        private MXCommon_WebReference.DefaultResponse MXResponse;
        private MSXExxxx_WebReference.DefaultResponse Response;
        private GroupBox[] g_AvChannels = new GroupBox[8];
        private CheckBox[] g_Channels = new CheckBox[8];
        private ComboBox[] g_ChannelsCoupling = new ComboBox[8];
        private ComboBox[] g_ChannelsSignal = new ComboBox[8];
        private ComboBox[] g_ChannelsPolarity = new ComboBox[8];
        private ComboBox[] g_ChannelsGain = new ComboBox[8];
        private ComboBox[] g_ChannelsICP = new ComboBox[8];
        private Label[] g_ChannelsTye = new Label[8];
        private ulong g_ulNbrOfChannels = 0;
        private int g_RetValue = 0;

        public FInitialisation()
        {
            InitializeComponent();
        }
        public class ListData
        {
            private string myItem;
            private long myValue;

            public ListData(string Item, long Value)
            {

                this.myItem = Item;
                this.myValue = Value;
            }

            public string Item
            {
                get { return myItem; }
            }

            public long Value
            {

                get { return myValue; }
            }
        }


        private void Combobox_set_SelectedValue(ComboBox cb, long value)
        {
            for (int Cpt = 0; Cpt < cb.Items.Count; Cpt++)
            {
                if (Convert.ToInt64(((ListData)cb.Items[Cpt]).Value) == value)
                {
                    cb.SelectedIndex = Cpt;
                    break;
                }
            }

        }

        private void GetConfiguration()
        {
            String[] sType = { "Voltage", "Current" };
            ulong ulType, ulICP, ulAcDc, ulSingleDiff, ulPolarity, ulGain, ulIcp, ulTimeBase, ulTimeBaseUnity, ulSamplingRate;

            for (ulong ulCpt = 0; ulCpt < g_ulNbrOfChannels; ulCpt++)
            {

                try
                {
                    Response = MSXExxxx.AnalogInputGetConfiguration(ulCpt, 0, out ulType, out ulICP, out ulAcDc, out ulSingleDiff, out ulPolarity, out ulGain, out ulIcp, out ulTimeBase, out ulTimeBaseUnity, out ulSamplingRate);

                    if (Response.iReturnValue != 0)
                    {
                        MessageBox.Show("AnalogInputGetConfiguration Error : " + Response.iReturnValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                        return;
                    }
                    Combobox_set_SelectedValue(g_ChannelsCoupling[ulCpt], (long)ulAcDc);
                    Combobox_set_SelectedValue(g_ChannelsSignal[ulCpt], (long)ulSingleDiff);
                    Combobox_set_SelectedValue(g_ChannelsPolarity[ulCpt],(long) ulPolarity);
                    Combobox_set_SelectedValue(g_ChannelsGain[ulCpt], (long) ulGain);
                    Combobox_set_SelectedValue(g_ChannelsICP[ulCpt], (long) ulIcp);
                    g_ChannelsICP[ulCpt].Enabled = (ulICP == 1);
                    g_ChannelsTye[ulCpt].Text = sType[ulType];
                    Combobox_set_SelectedValue(CB_TimeBase, (long) ulTimeBase);
                    Combobox_set_SelectedValue(CB_TimeUnity, (long)ulTimeBaseUnity);
                    TB_SamplinRate.Text = ulSamplingRate.ToString();

                }
                catch (Exception ex)
                {
                    MessageBox.Show("AnalogInputGetConfiguration Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    return;
                }
            }
        }

                
        private void SetConfiguration()
        {
            int syserrno;

            for (ulong ulCpt = 0; ulCpt < g_ulNbrOfChannels; ulCpt++)
            {
                try
                {
                    g_RetValue = MSXExxxx.AnalogInputSetSamplingRate(Convert.ToUInt64(CB_TimeBase.SelectedValue),
                                                                      Convert.ToUInt64(CB_TimeUnity.SelectedValue),
                                                                      Convert.ToUInt64(TB_SamplinRate.Text),
                                                                      0, 0, out syserrno);


                    if (g_RetValue != 0)
                    {
                        MessageBox.Show("AnalogInputSetSamplingRate Error : " + g_RetValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                        return;
                    }
                }
                catch (Exception ex)
                {
                    MessageBox.Show("AnalogInputSetSamplingRate Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    return;
                }

                if (g_Channels[ulCpt].Checked == true)
                {
                    try
                    {
                        g_RetValue = MSXExxxx.AnalogInputSetChannelConfiguration(ulCpt,
                                                                                    Convert.ToUInt64(g_ChannelsCoupling[ulCpt].SelectedValue),
                                                                                    Convert.ToUInt64(g_ChannelsSignal[ulCpt].SelectedValue),
                                                                                    Convert.ToUInt64(g_ChannelsPolarity[ulCpt].SelectedValue),
                                                                                    Convert.ToUInt64(g_ChannelsGain[ulCpt].SelectedValue),
                                                                                    Convert.ToUInt64(g_ChannelsICP[ulCpt].SelectedValue),
                                                                                    0, 0, out syserrno);


                        if (g_RetValue != 0)
                        {
                            MessageBox.Show("AnalogInputSetChannelConfiguration  Error : " + g_RetValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                            return;
                        }
                    }
                    catch (Exception ex)
                    {
                        MessageBox.Show("AnalogInputSetChannelConfiguration  Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                        return;
                    }
                }
            }
            MessageBox.Show("Configuration succesfully applied on the system.");
        }
        private void B_Connect_Click(object sender, EventArgs e)
        {
            System.Text.ASCIIEncoding enc = new System.Text.ASCIIEncoding();
            byte[] pcName = new byte[255];

            if ((TB_IPAddress_0.Text.ToString() == "") || (TB_IPAddress_1.Text.ToString() == "") || (TB_IPAddress_2.Text.ToString() == "") || (TB_IPAddress_3.Text.ToString() == ""))
            {
                MessageBox.Show("The IP address you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
            else
            {
                if ((Convert.ToUInt64(TB_IPAddress_0.Text.ToString(), 10) >= 0) && (Convert.ToUInt64(TB_IPAddress_0.Text.ToString(), 10) < 256))
                {
                    if ((Convert.ToUInt64(TB_IPAddress_1.Text.ToString(), 10) >= 0) && (Convert.ToUInt64(TB_IPAddress_1.Text.ToString(), 10) < 256))
                    {
                        if ((Convert.ToUInt64(TB_IPAddress_2.Text.ToString(), 10) >= 0) && (Convert.ToUInt64(TB_IPAddress_2.Text.ToString(), 10) < 256))
                        {
                            if ((Convert.ToUInt64(TB_IPAddress_3.Text.ToString(), 10) >= 0) && (Convert.ToUInt64(TB_IPAddress_3.Text.ToString(), 10) < 256))
                            {
                                B_SetConfiguration.Enabled = false;
                                MX_Common.Url = "http://" + TB_IPAddress_0.Text + "." + TB_IPAddress_1.Text + "." + TB_IPAddress_2.Text + "." + TB_IPAddress_3.Text + ":5555";
                                MSXExxxx.Url = MX_Common.Url;

                                // Get the module type
                                try
                                {
                                    MXResponse = MX_Common.GetModuleType(out pcName);
                                    if (MXResponse.iReturnValue != 0)
                                    {
                                        MessageBox.Show("GetModuleType Error : " + MXResponse.iReturnValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                                        return;
                                    }
                                }
                                catch (Exception ex)
                                {
                                    MessageBox.Show("GetModuleType Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                                    return;
                                }


                                try
                                {
                                    Response = MSXExxxx.AnalogInputGetNumberOfChannels(0, out g_ulNbrOfChannels);
                                    if (Response.iReturnValue != 0)
                                    {
                                        MessageBox.Show("AnalogInputGetNumberOfChannels Error : " + Response.iReturnValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                                        return;
                                    }

                                }
                                catch (Exception ex)
                                {
                                    MessageBox.Show("AnalogInputGetNumberOfChannels Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                                    return;
                                }

                                for (ulong i = 0; i < g_ulNbrOfChannels; i++)
                                {
                                    g_Channels[i].Enabled = true;
                                    g_Channels[i].Checked = true;
                                    g_AvChannels[i].Enabled = true;
                                }

                                for (ulong i = g_ulNbrOfChannels; i < 8; i++)
                                {
                                    g_Channels[i].Enabled = false;
                                    g_Channels[i].Checked = false;
                                    g_AvChannels[i].Enabled = false;
                                }

                                GetConfiguration();
                                B_SetConfiguration.Enabled = true;
                                GB_ChannelConfiguration.Enabled = true;
                            }
                            else
                            {
                                MessageBox.Show("The IP address (part 4) you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                            }
                        }
                        else
                        {
                            MessageBox.Show("The IP address (part 3) you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                        }
                    }
                    else
                    {
                        MessageBox.Show("The IP address (part 2) you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    }
                }
                else
                {
                    MessageBox.Show("The IP address (part 1) you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                }
            }

        }

        private void FInitialisation_Load(object sender, EventArgs e)
        {
            int i;
            MX_Common = new MXCommon_WebReference.MXCommon();
            MSXExxxx = new MSXExxxx_WebReference.MSXExxxx();
            MX_Common.Timeout = 5000;
            MSXExxxx.Timeout = 5000;

            // Save the channels check box
            g_AvChannels[0] = GB_Channel0;
            g_AvChannels[1] = GB_Channel1;
            g_AvChannels[2] = GB_Channel2;
            g_AvChannels[3] = GB_Channel3;
            g_AvChannels[4] = GB_Channel4;
            g_AvChannels[5] = GB_Channel5;
            g_AvChannels[6] = GB_Channel6;
            g_AvChannels[7] = GB_Channel7;

            g_Channels[0] = CB_Channel0;
            g_Channels[1] = CB_Channel1;
            g_Channels[2] = CB_Channel2;
            g_Channels[3] = CB_Channel3;
            g_Channels[4] = CB_Channel4;
            g_Channels[5] = CB_Channel5;
            g_Channels[6] = CB_Channel6;
            g_Channels[7] = CB_Channel7;

            g_ChannelsCoupling[0] = CB_Coupling0;
            g_ChannelsCoupling[1] = CB_Coupling1;
            g_ChannelsCoupling[2] = CB_Coupling2;
            g_ChannelsCoupling[3] = CB_Coupling3;
            g_ChannelsCoupling[4] = CB_Coupling4;
            g_ChannelsCoupling[5] = CB_Coupling5;
            g_ChannelsCoupling[6] = CB_Coupling6;
            g_ChannelsCoupling[7] = CB_Coupling7;

            g_ChannelsSignal[0] = CB_Signal0;
            g_ChannelsSignal[1] = CB_Signal1;
            g_ChannelsSignal[2] = CB_Signal2;
            g_ChannelsSignal[3] = CB_Signal3;
            g_ChannelsSignal[4] = CB_Signal4;
            g_ChannelsSignal[5] = CB_Signal5;
            g_ChannelsSignal[6] = CB_Signal6;
            g_ChannelsSignal[7] = CB_Signal7;

            g_ChannelsPolarity[0] = CB_Polarity0;
            g_ChannelsPolarity[1] = CB_Polarity1;
            g_ChannelsPolarity[2] = CB_Polarity2;
            g_ChannelsPolarity[3] = CB_Polarity3;
            g_ChannelsPolarity[4] = CB_Polarity4;
            g_ChannelsPolarity[5] = CB_Polarity5;
            g_ChannelsPolarity[6] = CB_Polarity6;
            g_ChannelsPolarity[7] = CB_Polarity7;

            g_ChannelsGain[0] = CB_Gain0;
            g_ChannelsGain[1] = CB_Gain1;
            g_ChannelsGain[2] = CB_Gain2;
            g_ChannelsGain[3] = CB_Gain3;
            g_ChannelsGain[4] = CB_Gain4;
            g_ChannelsGain[5] = CB_Gain5;
            g_ChannelsGain[6] = CB_Gain6;
            g_ChannelsGain[7] = CB_Gain7;

            g_ChannelsICP[0] = CB_ICP0;
            g_ChannelsICP[1] = CB_ICP1;
            g_ChannelsICP[2] = CB_ICP2;
            g_ChannelsICP[3] = CB_ICP3;
            g_ChannelsICP[4] = CB_ICP4;
            g_ChannelsICP[5] = CB_ICP5;
            g_ChannelsICP[6] = CB_ICP6;
            g_ChannelsICP[7] = CB_ICP7;

            g_ChannelsTye[0] = L_Type0;
            g_ChannelsTye[1] = L_Type1;
            g_ChannelsTye[2] = L_Type2;
            g_ChannelsTye[3] = L_Type3;
            g_ChannelsTye[4] = L_Type4;
            g_ChannelsTye[5] = L_Type5;
            g_ChannelsTye[6] = L_Type6;
            g_ChannelsTye[7] = L_Type7;

            GB_ChannelConfiguration.Enabled = false;
            B_SetConfiguration.Enabled = false;

            for (i = 0; i < 8; i++)
            {
                ArrayList ALCoupling = new ArrayList();
                ALCoupling.Add(new ListData("DC", 0));
                ALCoupling.Add(new ListData("AC", 1));

                g_ChannelsCoupling[i].DisplayMember = "Item";
                g_ChannelsCoupling[i].ValueMember = "Value";
                g_ChannelsCoupling[i].DataSource = ALCoupling;

                ArrayList ALSignal = new ArrayList();
                ALSignal.Add(new ListData("Single", 0));
                ALSignal.Add(new ListData("Differential", 1));

                g_ChannelsSignal[i].DisplayMember = "Item";
                g_ChannelsSignal[i].ValueMember = "Value";
                g_ChannelsSignal[i].DataSource = ALSignal;

                ArrayList ALPolarity = new ArrayList();
                ALPolarity.Add(new ListData("Bipolar", 0));
                ALPolarity.Add(new ListData("Unipolar", 1));

                g_ChannelsPolarity[i].DisplayMember = "Item";
                g_ChannelsPolarity[i].ValueMember = "Value";
                g_ChannelsPolarity[i].DataSource = ALPolarity;

                ArrayList ALGain = new ArrayList();
                ALGain.Add(new ListData("x1", 1));
                ALGain.Add(new ListData("x10", 10));
                ALGain.Add(new ListData("x100", 100));
                ALGain.Add(new ListData("x1000", 1000));

                g_ChannelsGain[i].DisplayMember = "Item";
                g_ChannelsGain[i].ValueMember = "Value";
                g_ChannelsGain[i].DataSource = ALGain;

                ArrayList ALICP = new ArrayList();
                ALICP.Add(new ListData("Disabled", 0));
                ALICP.Add(new ListData("Enabled", 1));

                g_ChannelsICP[i].DisplayMember = "Item";
                g_ChannelsICP[i].ValueMember = "Value";
                g_ChannelsICP[i].DataSource = ALICP;
            }

            ArrayList ALTimeBase = new ArrayList();
            ALTimeBase.Add(new ListData("1 MHz", 0));
            ALTimeBase.Add(new ListData("6.4 MHz", 1));

            CB_TimeBase.DisplayMember = "Item";
            CB_TimeBase.ValueMember = "Value";
            CB_TimeBase.DataSource = ALTimeBase;

            ArrayList ALTimeUnity = new ArrayList();
            ALTimeUnity.Add(new ListData("s", 0));
            ALTimeUnity.Add(new ListData("Hz", 5));

            CB_TimeUnity.DisplayMember = "Item";
            CB_TimeUnity.ValueMember = "Value";
            CB_TimeUnity.DataSource = ALTimeUnity;
        }

        private void B_SetConfiguration_Click(object sender, EventArgs e)
        {
            SetConfiguration();
        }


        private void TB_KeyPress_OnlyNumber(object sender, KeyPressEventArgs e)
        {
            if (!char.IsDigit(e.KeyChar) && !char.IsControl(e.KeyChar))
                e.Handled = true;
        }

        /// <summary>
        /// Update the constraints concerning the sampling rate
        /// </summary>
        private void UpdateSamplingRateConstraints()
        {
            if (this.CB_TimeBase.SelectedIndex < 0)
            {
                return;
            }

            if (this.CB_TimeUnity.SelectedIndex < 0)
            {
                return;
            }

            // 1MHz, s unity
            if ((this.CB_TimeBase.SelectedIndex == 0) && (this.CB_TimeUnity.SelectedIndex == 0))
            {
                this.samplingRateConstraintLabel.Text = "The value of \"Sampling rate\" must be between 8s and 65535s.";
                return;
            }
            // 1MHz, Hz unity
            if ((this.CB_TimeBase.SelectedIndex == 0) && (this.CB_TimeUnity.SelectedIndex == 1))
            {
                this.samplingRateConstraintLabel.Text = "The value of \"Sampling rate\" must be between 16Hz and 125000Hz." + Environment.NewLine;
                this.samplingRateConstraintLabel.Text += "The result of the operation 1000000 / \"Sampling rate\" must be an integer number (1000000 % \"Sampling rate\" = 0)." + Environment.NewLine;
                this.samplingRateConstraintLabel.Text += "Typical values: 125000, 100000, 62500, 50000, 40000, 31250, 25000, 20000, 15625, 12500, 10000, 8000, 6250, 5000, 4000, 3125, 2500, 2000, 1600, 1250, 1000, 100, 16";
                return;
            }
            // 6.4MHz, s unity
            if ((this.CB_TimeBase.SelectedIndex == 1) && (this.CB_TimeUnity.SelectedIndex == 0))
            {
                this.samplingRateConstraintLabel.Text = "The value of \"Sampling rate\" must be between 10s and 10235s." + Environment.NewLine;
                this.samplingRateConstraintLabel.Text += "The result of the operation 6,4 * \"Sampling rate\" must be an integer number.";
                return;
            }
            // 6.4MHz, Hz unity
            if ((this.CB_TimeBase.SelectedIndex == 1) && (this.CB_TimeUnity.SelectedIndex == 1))
            {
                this.samplingRateConstraintLabel.Text = "The value of \"Sampling rate\" must be between 100Hz and 128000Hz." + Environment.NewLine;
                this.samplingRateConstraintLabel.Text += "The result of the operation 6400000 / \"Sampling rate\" must be an integer number (6400000 % \"Sampling rate\" = 0)." + Environment.NewLine;
                this.samplingRateConstraintLabel.Text += "Typical values: 128000, 100000, 80000, 64000, 50000, 40000, 32000, 25000, 20000, 16000, 12800, 12500, 10000, 8000, 6400, 6250, 5000, 4000, 3200, 3125, 2500, 2000, 1600, 1280, 1000, 100";
                return;
            }
        }

        /// <summary>
        /// Update the color of the sampling rate field
        /// </summary>
        private void UpdateSamplingRateColor()
        {
            if (this.CB_TimeBase.SelectedIndex < 0)
            {
                this.TB_SamplinRate.BackColor = Color.Red;
                return;
            }

            if (this.CB_TimeUnity.SelectedIndex < 0)
            {
                this.TB_SamplinRate.BackColor = Color.Red;
                return;
            }

            // Convert the value
            uint value = 0;
            try
            {
                value = Convert.ToUInt32(this.TB_SamplinRate.Text);
            }
            catch (Exception)
            {
                this.TB_SamplinRate.BackColor = Color.Red;
                return;
            }

            // 1MHz, s unity
            if ((this.CB_TimeBase.SelectedIndex == 0) && (this.CB_TimeUnity.SelectedIndex == 0))
            {
                if ((value < 8) || (value > 65535))
                {
                    this.TB_SamplinRate.BackColor = Color.Red;
                    return;
                }
            }
            // 1MHz, Hz unity
            if ((this.CB_TimeBase.SelectedIndex == 0) && (this.CB_TimeUnity.SelectedIndex == 1))
            {
                if ((value < 16) || (value > 125000) || ((1000000 % value) != 0))
                {
                    this.TB_SamplinRate.BackColor = Color.Red;
                    return;
                }
            }
            // 6.4MHz, s unity
            if ((this.CB_TimeBase.SelectedIndex == 1) && (this.CB_TimeUnity.SelectedIndex == 0))
            {
                double tmpd = (double)value * 6.4;
                uint tmpu = (uint)((double)value * 6.4);
                if ((value < 10) || (value > 10235) || (tmpd != (double)tmpu))
                {
                    this.TB_SamplinRate.BackColor = Color.Red;
                    return;
                }
            }
            // 6.4MHz, Hz unity
            if ((this.CB_TimeBase.SelectedIndex == 1) && (this.CB_TimeUnity.SelectedIndex == 1))
            {
                if ((value < 100) || (value > 128000) || ((6400000 % value) != 0))
                {
                    this.TB_SamplinRate.BackColor = Color.Red;
                    return;
                }
            }

            // OK
            this.TB_SamplinRate.BackColor = Color.LightGreen;
        }

        /// <summary>
        /// The user changes the time base (clock base for sampling rate)
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void CB_TimeBase_SelectedIndexChanged(object sender, EventArgs e)
        {
            this.UpdateSamplingRateConstraints();
            this.UpdateSamplingRateColor();
        }

        /// <summary>
        /// The user changes the unity (sampling rate)
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void CB_TimeUnity_SelectedIndexChanged(object sender, EventArgs e)
        {
            this.UpdateSamplingRateConstraints();
            this.UpdateSamplingRateColor();

            if (this.CB_TimeUnity.SelectedIndex < 0)
            {
                this.samplingRateUnitLabel.Text = "";
                return;
            }
            if (this.CB_TimeUnity.SelectedIndex == 0)
            {
                this.samplingRateUnitLabel.Text = "s";
                return;
            }
            if (this.CB_TimeUnity.SelectedIndex == 1)
            {
                this.samplingRateUnitLabel.Text = "Hz";
                return;
            }
        }

        /// <summary>
        /// Text of the sampling rate has been changed
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void TB_SamplinRate_TextChanged(object sender, EventArgs e)
        {
            this.UpdateSamplingRateColor();
        }
    }
}